#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include <string.h>
#include <conio.h>

#define  ESC         0x1b
#define  ENTER       0x0d
#define  DIRKEY      0xFFFFFFE0
#define  UP          0x48
#define  DOWN        0x50
#define  LEFT        0x4B
#define  RIGHT       0x4D

struct mapinf{
  char sign;
  int color;
};

struct parameter{
  int pow;//
  int def;//h
  int dex;//p
  int mag;//
  int spd;//
};

struct parametershift{
  int pow[2];//
  int def[2];//h
  int dex[2];//p
  int mag[2];//
  int spd[2];//
};

struct player{
  char name[16];
  int mhp,mmp;
  int hp,mp;
  struct parameter par;
  struct parametershift pars;
  struct parameter field;
  struct parameter wear;
  int magic[32];
  int x,y;
  int place;
  double turn;
  int rec;
  int stm;
  int lv,exp;
};

struct noplayer{
  char name[16];
  char sign;
  int frd;
  int mhp,mmp;
  int hp,mp;
  struct parameter par;
  struct parametershift pars;
  struct parameter field;
  int x,y;
  int place;
  double turn;
  int rec;
  int ai;
  int exp;
  int rare;
};

struct item{
  char name[32];
  char sign;
  int color;
  int hp;
  int mp;
  struct parametershift pars;
  char expl[128];
  int price;
  int place;
  int inv;
  int x,y;
  int num;
  int prop;
  int rare;
};

struct magic{
  char name[32];
  int mp;
  int hrd;
  char expl[128];
};

struct material{
  char name[32];
  int prop;
  int lv;
};

struct crop{
  int prop;
  int planted[4]; //NAAA
  int hrd;
};

struct skill{
  int makeequip[2]; //i (Lv,cExp)
  int tool[2]; //
  int cook[2]; //
  int dig[2]; //̍z
  int fell[2]; //
  int fishing[2]; //ނ
  int plant[2]; //͔|
  int trade[2]; //
};

struct mapinf chip[]={
  {'.',15},//ʏ
  {'#',15},//
  {'>',15},//Ki
  {'<',15},//Ki
  {'*',8},//̍z
  {'*',11},//΂̍z
  {'|',10}, //
  {'#',10}, //΂
  {'~',13}, //
  {'~',11}, //
};
/*
  prop:
  0- |[V
  1- 
  2- H
  3- 
  4- @
  */
struct item itemlist[]=
{
  {"̗͉񕜂̖",'!',11,10,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"ނHP񕜂܂",100,0,0,0,0,0,0,3},
  {"͉񕜂̖",'!',11,0,10,{{0,0},{0,0},{0,0},{0,0},{0,0}},"ނMP񕜂܂",300,0,0,0,0,1,0,3},
  {"Ŗ",'!',13,-10,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"ނƃ_[W󂯂܂",50,0,0,0,0,2,0,2},
  {"͋z̖",'!',13,0,-10,{{0,0},{0,0},{0,0},{0,0},{0,0}},"ނMP܂",100,0,0,0,0,3,0,2},
  {"Ȃ",'!',11,0,0,{{5,10},{0,0},{0,0},{0,0},{0,0}},"ނƈꎞIɍU͂オ܂",100,0,0,0,0,4,0,2},
  {"キȂ",'!',13,0,0,{{-5,10},{0,0},{0,0},{0,0},{0,0}},"ނƈꎞIɍU͂܂",30,0,0,0,0,5,0,1},
  {"vɂȂ",'!',11,0,0,{{0,0},{5,10},{0,0},{0,0},{0,0}},"ނƈꎞIɖh͂オ܂",100,0,0,0,0,6,0,2},
  {"ɂȂ",'!',13,0,0,{{0,0},{-5,10},{0,0},{0,0},{0,0}},"ނƈꎞIɖh͂܂",30,0,0,0,0,7,0,1},
  {"pɂȂ",'!',11,0,0,{{0,0},{0,0},{5,10},{0,0},{0,0}},"ނƈꎞIɊpオ܂",100,0,0,0,0,8,0,2},
  {"spɂȂ",'!',13,0,0,{{0,0},{0,0},{-5,10},{0,0},{0,0}},"ނƈꎞIɊp܂",30,0,0,0,0,9,0,1},
  {"ǂȂ",'!',11,0,0,{{0,0},{0,0},{0,0},{5,10},{0,0}},"ނƈꎞIɖ͂オ܂",100,0,0,0,0,10,0,2},
  {"Ȃ",'!',13,0,0,{{0,0},{0,0},{0,0},{-5,10},{0,0}},"ނƈꎞIɖ͂܂",30,0,0,0,0,11,0,1},
  {"Ȃ",'!',11,0,0,{{0,0},{0,0},{0,0},{0,0},{30,10}},"ނƈꎞIɑオ܂",100,0,0,0,0,12,0,2},
  {"xȂ",'!',13,0,0,{{0,0},{0,0},{0,0},{0,0},{-30,10}},"ނƈꎞIɑ܂",30,0,0,0,0,13,0,1},
  {"V[ge|[g̊",'?',10,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"ǂނƋߋɃe|[g܂",50,0,0,0,0,14,1,1},
  {"e|[g̊",'?',10,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"ǂނƃe|[g܂",100,0,0,0,0,15,1,3},
  {"A҂̊",'?',10,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"ƂɋA܂",300,0,0,0,0,16,1,20},
  {"؂̎",'.',10,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"_ɐAƖ؂ł܂",10,0,0,0,0,17,3,20},
  {"ʕ̎",'.',10,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"_ɐAƉʕł܂",10,0,0,0,0,18,3,20},
  {"H",',',14,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"𖞂܂",50,0,0,0,0,19,2,10},
  {"ē1",',',14,0,0,{{5,50},{0,0},{5,50},{0,0},{0,0}},"͂o܂",100,0,0,0,0,20,2,0},
  {"ē2",',',14,0,0,{{10,100},{0,0},{10,100},{0,0},{0,0}},"͂o܂",200,0,0,0,0,21,2,0},
  {"ē3",',',14,0,0,{{15,150},{0,0},{15,150},{0,0},{0,0}},"͂o܂",400,0,0,0,0,22,2,0},
  {"ē4",',',14,0,0,{{20,200},{0,0},{20,200},{0,0},{0,0}},"͂o܂",800,0,0,0,0,23,2,0},
  {"ē5",',',14,0,0,{{25,250},{0,0},{25,250},{0,0},{0,0}},"͂o܂",1600,0,0,0,0,24,2,0},
  {"u1",',',14,0,0,{{0,0},{0,0},{0,0},{0,0},{10,50}},"̂yȂ܂",100,0,0,0,0,25,2,0},
  {"u2",',',14,0,0,{{0,0},{0,0},{0,0},{0,0},{20,100}},"̂yȂ܂",200,0,0,0,0,26,2,0},
  {"u3",',',14,0,0,{{0,0},{0,0},{0,0},{0,0},{30,150}},"̂yȂ܂",400,0,0,0,0,27,2,0},
  {"u4",',',14,0,0,{{0,0},{0,0},{0,0},{0,0},{40,200}},"̂yȂ܂",800,0,0,0,0,28,2,0},
  {"u5",',',14,0,0,{{0,0},{0,0},{0,0},{0,0},{50,250}},"̂yȂ܂",1600,0,0,0,0,29,2,0},
  {"̉Ă1",',',14,0,0,{{0,0},{10,50},{0,0},{0,0},{0,0}},"vɂȂ܂",100,0,0,0,0,30,2,0},
  {"̉Ă2",',',14,0,0,{{0,0},{20,100},{0,0},{0,0},{0,0}},"vɂȂ܂",200,0,0,0,0,31,2,0},
  {"̉Ă3",',',14,0,0,{{0,0},{30,150},{0,0},{0,0},{0,0}},"vɂȂ܂",400,0,0,0,0,32,2,0},
  {"̉Ă4",',',14,0,0,{{0,0},{40,200},{0,0},{0,0},{0,0}},"vɂȂ܂",800,0,0,0,0,33,2,0},
  {"̉Ă5",',',14,0,0,{{0,0},{50,250},{0,0},{0,0},{0,0}},"vɂȂ܂",1600,0,0,0,0,34,2,0},
  {"t[cT_1",',',14,0,0,{{0,0},{0,0},{0,0},{10,50},{0,0}},"Ȃ܂",100,0,0,0,0,35,2,0},
  {"t[cT_2",',',14,0,0,{{0,0},{0,0},{0,0},{20,100},{0,0}},"Ȃ܂",200,0,0,0,0,36,2,0},
  {"t[cT_3",',',14,0,0,{{0,0},{0,0},{0,0},{30,150},{0,0}},"Ȃ܂",400,0,0,0,0,37,2,0},
  {"t[cT_4",',',14,0,0,{{0,0},{0,0},{0,0},{40,200},{0,0}},"Ȃ܂",800,0,0,0,0,38,2,0},
  {"t[cT_5",',',14,0,0,{{0,0},{0,0},{0,0},{50,250},{0,0}},"Ȃ܂",1600,0,0,0,0,39,2,0},
  {"y̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"y𔭓܂",20,0,0,0,0,40,4,5},
  {"d̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"d𔭓܂",30,0,0,0,0,41,4,10},
  {"v̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"v𔭓܂",50,0,0,0,0,42,4,20},
  {"V[ge|[g̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"V[ge|[g𔭓܂",20,0,0,0,0,43,4,5},
  {"e|[g̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"e|[g𔭓܂",30,0,0,0,0,44,4,10},
  {"@̖̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"@̖𔭓܂",20,0,0,0,0,45,4,5},
  {"}WbN~TC̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"}WbN~TC𔭓܂",30,0,0,0,0,46,4,10},
  {"pY̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"pY𔭓܂",20,0,0,0,0,47,4,8},
  {"@̏̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"@̏𔭓܂",20,0,0,0,0,48,4,8},
  {"҂̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"҂𔭓܂",20,0,0,0,0,49,4,8},
  {"ȑ",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"r𔭓܂",20,0,0,0,0,50,4,8},
  {"͂̏",'_',11,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"MP񕜂܂",50,0,0,0,0,51,4,15},
  {"x_E̖",'!',13,0,0,{{0,0},{0,0},{0,0},{0,0},{0,0}},"ނƃx܂",1000,0,0,0,0,52,0,100},
};

struct noplayer npclist[]=
{
  {"˂",'r',-1,5,0,5,0,{5,7,15,1,60},{{5,0},{7,0},{15,0},{1,0},{60,0}},{0,0,0,0,0},0,0,0,0,0,0,5,1},
  {"",'h',-1,20,0,20,0,{15,10,5,1,50},{{15,0},{10,0},{5,0},{1,0},{50,0}},{0,0,0,0,0},0,0,0,0,0,0,8,2},
  {"",'w',-1,5,0,5,0,{3,5,20,1,80},{{3,0},{5,0},{20,0},{1,0},{80,0}},{0,0,0,0,0},0,0,0,0,0,0,5,1},
  {"",'s',-1,15,0,15,0,{15,7,15,1,30},{{15,0},{7,0},{15,0},{1,0},{30,0}},{0,0,0,0,0},0,0,0,0,0,0,8,2},
  {"pt",'m',-1,10,25,10,25,{3,7,15,15,70},{{3,0},{7,0},{15,0},{15,0},{70,0}},{0,0,0,0,0},0,0,0,0,0,1,8,3},
  {"ς炢",'d',-1,10,0,10,0,{5,9,15,15,50},{{5,0},{9,0},{15,0},{15,0},{50,0}},{0,0,0,0,0},0,0,0,0,0,2,5,3},
  {"T",'s',-1,20,0,20,0,{15,10,10,15,50},{{15,0},{10,0},{10,0},{15,0},{50,0}},{0,0,0,0,0},0,0,0,0,0,0,5,2},
  {"CJ",'c',-1,10,0,10,0,{12,10,15,15,70},{{12,0},{10,0},{15,0},{15,0},{70,0}},{0,0,0,0,0},0,0,0,0,0,0,5,2},
  {"^R",'o',-1,15,0,15,0,{10,10,15,15,60},{{10,0},{10,0},{15,0},{15,0},{60,0}},{0,0,0,0,0},0,0,0,0,0,0,5,2},
  {"NQ",'j',-1,10,0,10,0,{10,7,20,15,60},{{10,0},{7,0},{20,0},{15,0},{60,0}},{0,0,0,0,0},0,0,0,0,0,0,5,1},
  {"zv",'p',0,15,0,10,0,{20,15,10,5,60},{{10,0},{7,0},{20,0},{15,0},{60,0}},{0,0,0,0,0},0,0,0,0,0,0,5,3},
  {"؂",'p',0,15,0,10,0,{20,10,15,5,60},{{10,0},{7,0},{20,0},{15,0},{60,0}},{0,0,0,0,0},0,0,0,0,0,0,5,3},
  {"t",'p',0,15,0,10,0,{15,20,10,5,60},{{10,0},{7,0},{20,0},{15,0},{60,0}},{0,0,0,0,0},0,0,0,0,0,0,5,3},
};

struct noplayer minenpc[16];
struct noplayer forestnpc[16];
struct noplayer seanpc[16];

struct magic magiclist[]={
  {"y",5,15,"HP"},
  {"d",10,30,"HP"},
  {"v",20,60,"HP"},
  {"V[ge|[g",5,15,"ߋ̃e|[g"},
  {"e|[g",10,30,"ǂփe|[g"},
  {"@̖",5,15,"ΏۂɃ_[W"},
  {"}WbN~TC",10,30,"ΏۂɃ_[W"},
  {"̗͂",30,60,"̂܂ɂGɃ_[W"},
  {"pY",10,30,"ꎞIɍÚEpグ"},
  {"@̏",10,30,"ꎞIɖh͂グ"},
  {"",10,30,"ꎞIɖ͂グ"},
  {"r",10,30,"ꎞIɑxグ"},
};

struct material materiallist[]={
  //
  {"",0,1},
  {"",0,2},
  {"",0,3},
  {"}OlVE",0,4},
  {"A~jE",0,5},
  {"S",0,6},
  {"N",0,7},
  {"`^",0,8},

  //؍
  {"",1,1},
  {"C`E",1,2},
  {"K",1,3},
  {"",1,4},
  {"JGf",1,5},
  {"~",1,6},
  {"qmL",1,7},
  {"؍",1,8},

  //
  {"KX",2,1},
  {"",2,2},
  {"gR",2,3},
  {"r[",2,4},
  {"Tt@CA",2,5},
  {"Ő",2,6},
  {"sXY",2,7},
  {"_Ch",2,8},

  //H
  {"",3,1},
  {"",3,1},
  {"",3,1},
  {"ʕ",3,1},
};

char alphabet[]={"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"};
char numlist[]={"0123456789"};
char equiplist[5][8]={"","Z","","Xq","C"};

struct player pc;
struct skill skl;
struct noplayer npc[128];
struct mapinf mi[40][40];
int map[40][40];
char message[1024];
char buf[128];
int numnpc;
int numitem;
int maxinv,maxmat,maxequip;
char status[128];
char para[128];
int depth=1;
struct item itm[32];
int inv[32][2]; //(ACe̎,)*32
int mat[32][2]; //(}eA̎,)*32
int excite;
int arrow=20;
int tx,ty;
int npcmagic[]={0,3,5,1,4,6,2};
int rest=0;
int stayfloor;
int gathering[3]={0,0,0};
int dun;
int tohouse=0;
int farmlv,warehouselv;
int year,month,day,hour,min;
struct crop crp[32];
int money;
int townlv;
int shoplv;
int warehouseitm[32][2];
int warehousemat[32][2];
int eat[2];
int equipment[32][2]; //ށA\
int noidea;
int equipmyshop[32][3]; //ށA\Ali
int itemmyshop[32][3]; //ԍAAli
int itemnpcshop[32][2]; //ԍA
int equipnpcshop[32][2]; //ށA\

//vg^Cv錾
int dice(int,int,int);
void help(void);
int ab(int);
int alp2int(char);
int trpcalc(int,int,int);
void pcmove(int,int);
void npcmove(int,int,int);
void draw(void);
int targetmove(int,int,int);
int targetinfo();
int targetselect(void);
void createmap();
void dead(void);
void kill(int,int,int);
void itemconsume(int,int);
void materialconsume(int,int);
void useitem(int);
void useitemnpc(int,int);
void init(int);
char mygetch(void);
int numc2int(char[]);
void floordown(int);
void dungeon(void);
void gather(int,int);
void setnpclist(void);
void randwalk(int);
void farm(void);
void timeplus(void);
int grouthcalc(int[]);
void save(void);
int start(void);
void warehouseio(void);
int tomyshop(int);
int drop(void);
void sell(void);
void putmes(void);
void make(void);
void tonpcshop(void);
void buy(void);
void wearing(void);

//֐
void main(void){
  char ent;
  int enti;
  int i;
  int tcolor,bgcolor;
  int attr;
  HANDLE handle;
  CONSOLE_SCREEN_BUFFER_INFO csbi;

  srand((unsigned)time(NULL));

  handle = GetStdHandle(STD_OUTPUT_HANDLE);
  GetConsoleScreenBufferInfo(handle, &csbi);

  i=start();
  init(i);

  while(1==1){
    sprintf(message,"");
  input:
    if(eat[1]<=0){
      system("cls");
      printf("H\n\n");
      printf("a:\n");
      printf("b:\n");
      printf("c:o\n");
      printf("d:̂Ă\n");
      printf("e:Hׂ\n");
      printf("f:\n");
      printf("g:\n");
      printf("h:g\n");
      printf("i:\n");
      printf("j:Z[u\n");
      printf("k:I\n");

      printf("\nHP:%d/%d MP:%d/%d",pc.hp,pc.mhp,pc.mp,pc.mmp);
      printf("\nF%d~\ttF%dN%d%d\tԁF%d%d\n",money,year,month,day,hour,min/100);
      bgcolor=0;
      if(pc.stm==0){
        tcolor=12;
        attr=bgcolor*16+tcolor;
        SetConsoleTextAttribute(handle,attr);
        printf("쎀");
        pc.hp=pc.hp-pc.mhp/10;
      }else if(pc.stm<50){
        tcolor=12;
        attr=bgcolor*16+tcolor;
        SetConsoleTextAttribute(handle,attr);
        printf("Q");
      }else if(pc.stm<150){
        tcolor=14;
        attr=bgcolor*16+tcolor;
        SetConsoleTextAttribute(handle,attr);
        printf("");
      }else if(pc.stm<300){
        tcolor=15;
        attr=bgcolor*16+tcolor;
        SetConsoleTextAttribute(handle,attr);
        printf("");
      }
      tcolor=15;
      attr=bgcolor*16+tcolor;
      SetConsoleTextAttribute(handle,attr);
      putmes();
    }

    if(0<eat[1]){
      ent=ENTER;
    }else{
      ent=mygetch();
    }
    switch (ent){
    case ENTER:
      break;
    case 'a': //
      buy();
      break;

    case 'b': //
      system("cls");
      printf("𔄂H\n\n");
      printf("a:ACe\n");
      printf("b:i\n");
      ent=mygetch();

      switch(ent){
      case 'a':
        tomyshop(0);
        break;
      case 'b':
        tomyshop(1);
      }
      break;

    case 'c': //o
      system("cls");
      printf("ǂɏoH\n\n");
      printf("a:zR\n");
      printf("b:X\n");
      printf("c:\n");
      printf("d:_\n");
      printf("e:q\n");

      ent=mygetch();
      enti=alp2int(ent);
      dun=enti;
      switch(ent){
      case 'a':
        dungeon();
        break;

      case 'b':
        dungeon();
        break;

      case 'c':
        dungeon();
        break;

      case 'd':
        farm();
        break;

      case 'e':
        warehouseio();
        break;

      default:
        goto input;
      }
      break;

    case 'd': //̂Ă
      drop();
      break;

    case 'e': //Hׂ
      printf("HׂH\n\n");
      for(i=0;i<maxinv;i++){
        if(inv[i][0]==-1) break;
        if(itemlist[inv[i][0]].prop==2) printf("%c:%s x%d\n",alphabet[i],itemlist[inv[i][0]].name,inv[i][1]);
      }
      ent=mygetch();
      enti=alp2int(ent);
      if(itemlist[inv[enti][0]].prop==2){
        eat[0]=enti;
        eat[1]=10;
      }else{
        printf("͐Hוł͂Ȃ\n");
        printf("L[Ă");
        mygetch();
      }
      break;

    case 'f': //
      wearing();
      break;

    case 'g': //
      make();
      break;

    case 'h': //g
      system("cls");
      printf("gH\n\n");
      printf("a:q\n");
      printf("b:X\n");
      printf("c:_\n");
      printf("d:X\n\n");

      ent=mygetch();
      switch(ent){
      case 'a':
        if(warehouselv==32){
          printf("ȏgłȂ\n");
        }else{
          printf("%d~Ŋgł\n",warehouselv*1000);
          printf("gH\n");
          printf("y/n");
          ent=mygetch();
          if(ent=='y'){
            if(money<warehouselv*1000){
              printf("Ȃ\n");
            }else{
              money=money-warehouselv*1000;
              warehouselv++;
              printf("qɂg\n");
            }
          }
        }
        break;
      case 'b':
        if(shoplv==32){
          printf("ȏgłȂ\n");
        }else{
          printf("%d~Ŋgł\n",shoplv*1000);
          printf("gH\n");
          printf("y/n");
          ent=mygetch();
          if(ent=='y'){
            if(money<shoplv*1000){
              printf("Ȃ\n");
            }else{
              money=money-shoplv*1000;
              shoplv++;
              printf("Xg\n");
            }
          }
        }
        break;
      case 'c':
        if(farmlv==32){
          printf("ȏgłȂ\n");
        }else{
          printf("%d~Ŋgł\n",farmlv*1000);
          printf("gH\n");
          printf("y/n");
          ent=mygetch();
          if(ent=='y'){
            if(money<farmlv*1000){
              printf("Ȃ\n");
            }else{
              money=money-farmlv*1000;
              farmlv++;
              printf("_g\n");
            }
          }
        }
        break;
      case 'd':
        if(townlv==32){
          printf("ȏgłȂ\n");
        }else{
          printf("%d~Ŋgł\n",townlv*10000);
          printf("gH\n");
          printf("y/n");
          ent=mygetch();
          if(ent=='y'){
            if(money<townlv*10000){
              printf("Ȃ\n");
            }else{
              money=money-townlv*10000;
              townlv++;
              printf("Xg");
            }
          }
        }
        break;
      }
      break;

    case 'i': //
      system("cls");
      printf("O:%s(Lv.%d)\n\n",pc.name,pc.lv);
      printf("?\n");
      printf("a:p[^\n");
      printf("b:i\n");
      printf("c:q\n");
      ent=mygetch();
      system("cls");
      switch(ent){
      case 'a':
        printf("U:%d h:%d p:%d :%d :%d\n",pc.par.pow,pc.par.def,pc.par.dex,pc.par.mag,pc.par.spd);
        printf("̍U:%d Z̖h:%d ̊p:%d ̖:%d C̑:%d\n\n",
               pc.wear.pow,pc.wear.def,pc.wear.dex,pc.wear.mag,pc.wear.spd);
        printf("XLx\n");
        printf("퐻:%d h:%d :%d :%d ̍z:%d :%d ނ:%d ͔|:%d :%d\n\n",
               skl.makeequip[0],
               skl.tool[0],
               skl.cook[0],
               skl.dig[0],
               skl.fell[0],
               skl.fishing[0],
               skl.plant[0],
               skl.trade[0]);
        printf("̑\n");
        printf("qLv:%d,XLv:%d,_Lv:%d,XLv:%d\n\n",warehouselv,shoplv,farmlv,townlv);
        printf("L[Ă\n");
        mygetch();
        break;
      case 'b':
        printf("ACe\n\n");
        for(i=0;i<maxinv;i++){
          if(inv[i][0]==-1) break;
          printf("%s x%d\n",itemlist[inv[i][0]].name,inv[i][1]);
        }
        printf("\n");
        printf("f\n\n");
        for(i=0;i<maxmat;i++){
          if(mat[i][0]==-1) break;
          printf("%s x%d\n",materiallist[mat[i][0]].name,mat[i][1]);
        }
        printf("L[Ă\n");
        mygetch();
        break;
      case 'c':
        printf("ACe\n\n");
        for(i=0;i<warehouselv;i++){
          if(warehouseitm[i][0]==-1) break;
          printf("%s x%d\n",itemlist[warehouseitm[i][0]].name,warehouseitm[i][1]);
        }
        printf("\n");
        printf("f\n\n");
        for(i=0;i<warehouselv;i++){
          if(warehousemat[i][0]==-1) break;
          printf("%s x%d\n",materiallist[warehousemat[i][0]].name,warehousemat[i][1]);
        }
        printf("L[Ă\n");
        mygetch();
        break;
      }
      break;

    case 'j': //Z[u
      save();
      break;

    case 'k': //I
      system("cls");
      printf("{ɏIH\n");
      printf("y/n\n");
      ent=mygetch();
      if(ent=='y'){
        exit(0);
      }else{
        goto input;
      }
      break;
    }

    if(0<eat[1]){
      eat[1]--;
      if(eat[1]==0){
        pc.stm=pc.stm+300;
        itemconsume(eat[0],1);
        printf("Ȃ%sH׏I\n",itemlist[inv[eat[0]][0]].name);
        printf("L[Ă");
        mygetch();
      }
    }
    timeplus();
    if(pc.hp<0) dead();
  }
}

int tomyshop(ts){
  int i,enti;
  char ent;
  int b;
  char numc[16];
  int num,price;
  int fair;

  if(ts==0){
    while(1==1){
      system("cls");
      printf("𔄂H\n\n");
      for(i=0;i<maxinv;i++){
        if(inv[i][0]==-1) break;
        if(itemlist[inv[i][0]].prop==4){
          printf("%c:%s(c%d)\n",alphabet[i],itemlist[inv[i][0]].name,inv[i][1]);
        }else{
          printf("%c:%s x%d\n",alphabet[i],itemlist[inv[i][0]].name,inv[i][1]);
        }
      }
      printf("\nESCŏI\n");

      ent=mygetch();
      if(ent==ESC) return 0;
      enti=alp2int(ent);
      if((maxinv<=enti)||(inv[enti][0]==-1)){
      }else{
        if(itemlist[inv[enti][0]].prop==4){
          for(i=0;i<shoplv;i++){
            if(itemmyshop[i][0]==-1) break;
          }
          if(i==shoplv){
            printf("ȏuȂ\n");
            printf("L[Ă\n");
            mygetch();
          }else{
            system("cls");
            fair=itemlist[inv[enti][0]].price*(10+inv[enti][1]);
            printf("ŔH (Ki%d~)\n",fair);
            scanf("%s",numc);
            price=numc2int(numc);
            if(0<price){
              printf("Ȃ%s%d~Ŕɏo\n",itemlist[inv[enti][0]].name,price);
              itemmyshop[i][0]=inv[enti][0];
              itemmyshop[i][1]=inv[enti][1];
              itemmyshop[i][2]=price;
              for(i=enti;i<maxinv-1;i++){
                inv[i][0]=inv[i+1][0];
                inv[i][1]=inv[i+1][1];
              }
              inv[maxinv-1][0]=-1;
              printf("L[Ă\n");
              mygetch();
            }
          }
        }else{
          for(i=0;i<shoplv;i++){
            if(itemmyshop[i][0]==-1) break;
            if(itemmyshop[i][0]==inv[enti][0]) break;
          }
          if(i==shoplv){
            printf("ȏuȂ\n");
            printf("L[Ă\n");
            mygetch();
          }else{
            system("cls");
            printf("%sH\n",itemlist[inv[enti][0]].name);
            scanf("%s",numc);
            num=numc2int(numc);
            if(0<num){
              if(itemmyshop[i][0]==-1){
                printf("ЂƂŔH (Ki%d~/)\n",itemlist[inv[enti][0]].price);
                scanf("%s",numc);
                price=numc2int(numc);
                if(0<price){
                  if(inv[enti][1]<=num){
                    printf("Ȃ%sЂƂ%d~őSɏo\n",itemlist[inv[enti][0]].name,price);
                    itemmyshop[i][0]=inv[enti][0];
                    itemmyshop[i][1]=inv[enti][1];
                    itemmyshop[i][2]=price;
                    itemconsume(enti,inv[enti][1]);
                  }else{
                    printf("Ȃ%sЂƂ%d~%dɏo\n",itemlist[inv[enti][0]].name,price,num);
                    itemmyshop[i][0]=inv[enti][0];
                    itemmyshop[i][1]=num;
                    itemmyshop[i][2]=price;
                    itemconsume(enti,num);
                  }
                  printf("L[Ă\n");
                  mygetch();
                }
              }else{
                if(inv[enti][1]<=num){
                  printf("Ȃ%sSɏo\n",itemlist[inv[enti][0]].name);
                  itemmyshop[i][0]=inv[enti][0];
                  itemmyshop[i][1]=inv[enti][1];
                  itemmyshop[i][2]=price;
                  itemconsume(enti,inv[enti][1]);
                }else{
                  printf("Ȃ%s%dɏo\n",itemlist[inv[enti][0]].name,num);
                  itemmyshop[i][0]=inv[enti][0];
                  itemmyshop[i][1]=num;
                  itemmyshop[i][2]=price;
                  itemconsume(enti,num);
                }
                printf("L[Ă\n");
                mygetch();
              }
            }
          }
        }
      }
    }
  }else if(ts==1){
    while(1==1){
      system("cls");
      printf("𔄂H\n\n");
      for(i=0;i<maxequip;i++){
        if(equipment[i][0]==-1) break;
        printf("%c:%s(i%d)\n",alphabet[i],equiplist[equipment[i][0]],equipment[1]);
      }
      printf("\nESCŏI");

      ent=mygetch();
      if(ent==ESC) return 0;
      enti=alp2int(ent);
      if((maxequip<=enti)||(equipment[enti][0]==-1)){
      }else{
        for(i=0;i<shoplv;i++){
          if(equipmyshop[i][0]==-1) break;
        }
        if(i==shoplv){
          printf("ȏuȂ\n");
          printf("L[Ă\n");
          mygetch();
        }else{
          b=1;
          while(b==1){
            fair=equipment[enti][1]*500;
            system("cls");
            printf("%sŔH (Ki%d~)\n",equiplist[equipment[enti][0]],fair);
            scanf("%s",numc);
            price=numc2int(numc);
            if(0<price) b=0;
          }
          printf("%s%d~Ŕɏo\n",equiplist[equipment[enti][0]],price);
          equipmyshop[i][0]=equipment[enti][0];
          equipmyshop[i][1]=equipment[enti][1];
          equipmyshop[i][2]=price;

          for(i=enti;i<maxequip-1;i++){
            equipment[i][0]=equipment[i+1][0];
            equipment[i][1]=equipment[i+1][1];
          }
          equipment[maxequip][0]=-1;

          printf("L[Ă");
          mygetch();
        }
      }
    }
  }
}

void warehouseio(void){
  char ent,numc[16];
  int i,j,enti;
  int num;
  int b;

  ent=0;
  while(ent!='q'){
    system("cls");
    printf("ǂH\n\n");
    printf("a:ACe̕ۊ\n");
    printf("b:ACe̎o\n");
    printf("c:fނ̕ۊ\n");
    printf("d:fނ̎o\n");
    printf("q:ƂɋA\n");

    ent=mygetch();
    system("cls");
    switch(ent){
    case 'a':
      printf("ۊǂH\n\n");
      for(i=0;i<maxinv;i++){
        if(inv[i][0]==-1) break;
        if(itemlist[inv[i][0]].prop==4){
          printf("%c:%s(c%d)\n",alphabet[i],itemlist[inv[i][0]].name,inv[i][1]);
        }else{
          printf("%c:%s x%d\n",alphabet[i],itemlist[inv[i][0]].name,inv[i][1]);
        }
      }
      ent=mygetch();
      enti=alp2int(ent);
      if((maxinv<=enti)||(inv[enti][0]==-1)){
      }else{
        if(itemlist[inv[enti][0]].prop==4){
          for(i=0;i<warehouselv;i++){
            if(warehouseitm[i][0]==-1) break;
          }
          if(i==warehouselv){
            printf("ȏȂ\n");
            printf("L[Ă\n");
            mygetch();
          }else{
            warehouseitm[i][0]=inv[enti][0];
            warehouseitm[i][1]=inv[enti][1];
            for(j=enti;j<maxinv-1;j++){
              inv[j][0]=inv[j+1][0];
              inv[j][1]=inv[j+1][1];
            }
            inv[maxinv-1][0]=-1;
            printf("%d(c%d)ۊǂ\n",itemlist[warehouseitm[i][0]].name,warehouseitm[i][1]);
          }
        }else{
          for(i=0;i<warehouselv;i++){
            if(warehouseitm[i][0]==inv[enti][0])break;
            if(warehouseitm[i][0]==-1) break;
          }
          if(i==warehouselv){
            printf("ȏȂ\n");
            printf("L[Ă\n");
            mygetch();
          }else{
            b=1;
            while(b==1){
              system("cls");
              printf("%sۊǂH\n",itemlist[inv[enti][0]].name);
              scanf("%s",numc);
              num=numc2int(numc);
              if(0<num){
                if(inv[enti][1]<=num){
                  printf("%sSۊǂ\n",itemlist[inv[enti][0]].name);
                  itemconsume(enti,inv[i][1]);
                  if(warehouseitm[i][0]==-1){
                    warehouseitm[i][0]=inv[enti][0];
                    warehouseitm[i][1]=inv[enti][1];
                  }else{
                    warehouseitm[i][1]=warehouseitm[i][1]+inv[enti][1];
                  }
                }else{
                  printf("%s%dۊǂ\n",itemlist[inv[enti][0]].name,num);
                  itemconsume(enti,num);
                  if(warehouseitm[i][0]==-1){
                    warehouseitm[i][0]=inv[enti][0];
                    warehouseitm[i][1]=num;
                  }else{
                    warehouseitm[i][1]=warehouseitm[i][1]+num;
                  }
                }
                printf("L[Ă\n");
                mygetch();
                b=0;
              }
            }
          }
        }
      }
      break;
    case 'b':
      printf("oH\n\n");
      for(i=0;i<warehouselv;i++){
        if(warehouseitm[i][0]==-1) break;
        printf("%c:%s x%d\n",alphabet[i],itemlist[warehouseitm[i][0]].name,warehouseitm[i][1]);
      }
      ent=mygetch();
      enti=alp2int(ent);
      if((warehouselv<=enti)||(warehouseitm[enti][0]==-1)){
      }else{
        for(i=0;i<maxinv;i++){
          if(inv[i][0]==warehouseitm[enti][0])break;
          if(inv[i][0]==-1) break;
        }
        if(i==maxinv){
          printf("ȏ㎝ĂȂ\n");
          printf("L[Ă\n");
          mygetch();
        }else{
          b=1;
          while(b==1){
            system("cls");
            printf("%soH\n",itemlist[warehouseitm[enti][0]].name);
            scanf("%s",numc);
            num=numc2int(numc);
            if(0<num){
              if(inv[enti][1]<=num){
                printf("%sSo\n",itemlist[warehouseitm[enti][0]].name);
                if(warehouseitm[enti][1]<=0){
                  for(j=enti;j<warehouselv-1;j++){
                    warehouseitm[j][0]=warehouseitm[j+1][0];
                    warehouseitm[j][1]=warehouseitm[j+1][1];
                  }
                  warehouseitm[warehouselv-1][0]=-1;
                }
                if(inv[i][0]==-1){
                  inv[i][0]=warehouseitm[enti][0];
                  inv[i][1]=warehouseitm[enti][1];
                }else{
                 inv[i][1]=inv[i][1]+warehouseitm[enti][1];
                }
              }else{
                printf("%s%do\n",itemlist[warehouseitm[enti][0]].name,num);
                warehouseitm[i][1]=warehouseitm[i][1]-num;
                if(inv[i][0]==-1){
                  inv[i][0]=warehouseitm[enti][0];
                  inv[i][1]=num;
                }else{
                  inv[i][1]=inv[i][1]+num;
                }
              }
              printf("L[Ă\n");
              mygetch();
              b=0;
            }
          }
        }
      }
      break;
    case 'c':
      printf("ۊǂH\n\n");
      for(i=0;i<maxmat;i++){
        if(inv[i][0]==-1) break;
        printf("%c:%s x%d\n",alphabet[i],materiallist[mat[i][0]].name,mat[i][1]);
      }
      ent=mygetch();
      enti=alp2int(ent);
      if((maxmat<=enti)||(mat[enti][0]==-1)){
      }else{
        for(i=0;i<warehouselv;i++){
          if(warehousemat[i][0]==mat[enti][0])break;
          if(warehousemat[i][0]==-1) break;
        }
        if(i==warehouselv){
          printf("ȏȂ\n");
          printf("L[Ă\n");
          mygetch();
        }else{
          b=1;
          while(b==1){
            system("cls");
            printf("%sۊǂH\n",materiallist[mat[enti][0]].name);
            scanf("%s",numc);
            num=numc2int(numc);
            if(0<num){
              if(mat[enti][1]<=num){
                printf("%sSۊǂ\n",itemlist[inv[enti][0]].name);
                materialconsume(enti,mat[i][1]);
                if(warehousemat[i][0]==-1){
                  warehousemat[i][0]=mat[enti][0];
                  warehousemat[i][1]=mat[enti][1];
                }else{
                  warehousemat[i][1]=warehousemat[i][1]+mat[enti][1];
                }
              }else{
                printf("%s%dۊǂ\n",materiallist[mat[enti][0]].name,num);
                materialconsume(enti,num);
                if(warehousemat[i][0]==-1){
                  warehousemat[i][0]=mat[enti][0];
                  warehousemat[i][1]=num;
                }else{
                  warehousemat[i][1]=warehousemat[i][1]+num;
                }
              }
              printf("L[Ă\n");
              mygetch();
              b=0;
            }
          }
        }
      }
      break;
    case 'd':
      printf("oH\n\n");
      for(i=0;i<warehouselv;i++){
        if(warehousemat[i][0]==-1) break;
        printf("%c:%s x%d\n",alphabet[i],materiallist[warehousemat[i][0]].name,warehousemat[i][1]);
      }
      ent=mygetch();
      enti=alp2int(ent);
      if((warehouselv<=enti)||(warehousemat[enti][0]==-1)){
      }else{
        for(i=0;i<maxmat;i++){
          if(inv[i][0]==warehousemat[enti][0])break;
          if(inv[i][0]==-1) break;
        }
        if(i==maxmat){
          printf("ȏ㎝ĂȂ\n");
          printf("L[Ă\n");
          mygetch();
        }else{
          b=1;
          while(b==1){
            system("cls");
            printf("%soH\n",materiallist[warehousemat[enti][0]].name);
            scanf("%s",numc);
            num=numc2int(numc);
            if(0<num){
              if(mat[enti][1]<=num){
                printf("%sSo\n",materiallist[warehousemat[enti][0]].name);
                if(warehousemat[enti][1]<=0){
                  for(j=enti;j<warehouselv-1;j++){
                    warehousemat[j][0]=warehousemat[j+1][0];
                    warehousemat[j][1]=warehousemat[j+1][1];
                  }
                  warehousemat[warehouselv-1][0]=-1;
                }
                if(inv[i][0]==-1){
                  mat[i][0]=warehousemat[enti][0];
                  mat[i][1]=warehousemat[enti][1];
                }else{
                 mat[i][1]=mat[i][1]+warehousemat[enti][1];
                }
              }else{
                printf("%s%do\n",materiallist[warehousemat[enti][0]].name,num);
                warehousemat[i][1]=warehousemat[i][1]-num;
                if(inv[i][0]==-1){
                  mat[i][0]=warehousemat[enti][0];
                  mat[i][1]=num;
                }else{
                  mat[i][1]=mat[i][1]+num;
                }
              }
              printf("L[Ă\n");
              mygetch();
              b=0;
            }
          }
        }
      }
      break;
    }
  }
}

void save(void){
  char filename[16];
  char pcname[16][16];
  char pclv[16];
  int i;
  FILE* f;
  char ent;
  int enti;

  for(i=0;i<16;i++){
    sprintf(pcname[i],"nochar");
    pclv[i]=0;
  }

  f=fopen("save/save","r");
  for(i=0;i<16;i++){
    if(fscanf(f,"%s %d",pcname[i],&pclv[i])==EOF) break;
  }
  fclose(f);

selectsavefile:
  enti=-1;
  while(enti==-1){
    system("cls");
    printf("ǂɃZ[u܂\n\n");
    for(i=0;i<16;i++){
      if(pclv[i]==0){
        printf("%c:Z[uf[^܂\n",alphabet[i]);
      }else{
        printf("%c:%s(Lv.%d)\n",alphabet[i],pcname[i],pclv[i]);
      }
    }

    ent=mygetch();
    enti=alp2int(ent);
    if(16<=enti) enti=-1;
  }
  if(pclv[enti]==-1){
    sprintf(pcname[enti],"%s",pc.name);
    pclv[enti]=pc.lv;
  }else{
    printf("f[^㏑܂H\n");
    printf("y/n");
    ent=mygetch();
    if(ent=='y'){
      sprintf(pcname[enti],"%s",pc.name);
      pclv[enti]=pc.lv;
    }else{
      goto selectsavefile;
    }
  }

  f=fopen("save/save","w");
  for(i=0;i<16;i++){
    fprintf(f,"%s %d\n",pcname[i],pclv[i]);
  }
  fclose(f);

  sprintf(filename,"save/save%d",enti);
  f=fopen(filename,"w");

  switch(numnpc){
  case 16:
    fprintf(f,"0\n");
    break;
  case 32:
    fprintf(f,"1\n");
    break;
  case 64:
    fprintf(f,"2\n");
    break;
  case 128:
    fprintf(f,"3\n");
    break;
  }

  fprintf(f,"%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
          pc.name,
          pc.mhp,pc.mmp,
          pc.par.pow,pc.par.def,pc.par.dex,pc.par.mag,pc.par.spd,
          pc.wear.pow,pc.wear.def,pc.wear.dex,pc.wear.mag,pc.wear.spd,
          pc.lv,pc.exp
          ); //Xe[^X
  fprintf(f,"%d %d %d %d %d\n",pc.wear.pow,pc.wear.def,pc.wear.dex,pc.wear.mag,pc.wear.spd); //i
  for(i=0;i<32;i++){
    fprintf(f,"%d ",pc.magic[i]); //@
  }
  fprintf(f,"%d %d %d %d %d %d %d\n",year,month,day,hour,min,pc.stm,money); //ԁA
  for(i=0;i<maxinv;i++) fprintf(f,"%d %d ",inv[i][0],inv[i][1]); //ACe
  fprintf(f,"\n");
  for(i=0;i<maxmat;i++) fprintf(f,"%d %d ",mat[i][0],mat[i][1]); //}eA
  fprintf(f,"\n");
  for(i=0;i<maxequip;i++) fprintf(f,"%d %d ",equipment[i][0],equipment[i][1]); //i
  fprintf(f,"\n");
  fprintf(f,"%d %d ",skl.makeequip[0],skl.makeequip[1]); //XL
  fprintf(f,"%d %d ",skl.tool[0],skl.tool[1]);
  fprintf(f,"%d %d ",skl.cook[0],skl.cook[1]);
  fprintf(f,"%d %d ",skl.dig[0],skl.dig[1]);
  fprintf(f,"%d %d ",skl.fell[0],skl.fell[1]);
  fprintf(f,"%d %d ",skl.fishing[0],skl.fishing[1]);
  fprintf(f,"%d %d ",skl.plant[0],skl.plant[1]);
  fprintf(f,"%d %d\n",skl.trade[0],skl.trade[1]);
  fprintf(f,"%d %d %d %d\n",warehouselv,farmlv,townlv,shoplv); //K
  for(i=0;i<warehouselv;i++) fprintf(f,"%d %d ",warehouseitm[i][0],warehouseitm[i][1]);
  fprintf(f,"\n");
  for(i=0;i<warehouselv;i++) fprintf(f,"%d %d ",warehousemat[i][0],warehousemat[i][1]);
  fprintf(f,"\n");
  for(i=0;i<farmlv;i++) fprintf(f,"%d %d %d %d %d %d",
                                crp[i].prop,crp[i].planted[0],crp[i].planted[1],crp[i].planted[2],crp[i].planted[3],crp[i].hrd);
  fprintf(f,"\n");
  for(i=0;i<shoplv;i++) fprintf(f,"%d %d %d ",equipmyshop[i][0],equipmyshop[i][1],equipmyshop[i][2]); //X葕
  fprintf(f,"\n");
  for(i=0;i<shoplv;i++) fprintf(f,"%d %d %d ",itemmyshop[i][0],itemmyshop[i][1],itemmyshop[i][2]); //XACe
  fprintf(f,"\n");
  for(i=0;i<townlv;i++) fprintf(f,"%d %d ",itemnpcshop[i][0],itemnpcshop[i][1]); //XACe
  fprintf(f,"\n");
  for(i=0;i<townlv;i++) fprintf(f,"%d %d ",equipnpcshop[i][0],equipnpcshop[i][1]); //X葕

  fclose(f);

  printf("Z[u܂\n");
  printf("L[Ă\n");
  mygetch();
}

void farm(void){
  int i,j,k;
  int grouth[16];
  char propname[16][16];
  char grouthcond[4][32];
  char ent;
  int enti;
  int matnum;
  int rnd;

  sprintf(propname[0],"");
  sprintf(propname[1],"ʕ");

  sprintf(grouthcond[0],"܂肪oĂȂ");
  sprintf(grouthcond[1],"萁Ă");
  sprintf(grouthcond[2],"Ă");
  sprintf(grouthcond[3],"nł");

  for(i=0;i<farmlv;i++){
    grouth[i]=grouthcalc(crp[i].planted);
  }

  ent=0;
  while(ent!='q'){
  input:
    system("cls");
    for(i=0;i<farmlv;i++){
      if(crp[i].prop==-1) break;
      printf("%s%s\n",propname[crp[i].prop],grouthcond[grouth[i]]);
    }

    printf("\nǂH\n\n");
    printf("p:܂\n");
    printf("h:n\n");
    printf("q:ƂɋA\n");

    ent=mygetch();
    switch(ent){
    case ESC:
      ent='q';
      break;

    case 'p'://A
      if(i<farmlv){
      selectseed:
        system("cls");
        printf("AH\n\n");
        for(j=0;j<maxinv;j++){
          if(itemlist[inv[j][0]].prop==3){
            printf("%c:%s x%d\n",alphabet[j],itemlist[inv[j][0]].name,inv[i][1]);
          }
        }

        ent=mygetch();
        if(ent==ESC) goto input;
        enti=alp2int(ent);
        if((enti>=maxinv)||(inv[enti][0]==-1)){
          printf("ȃACe݂͑Ȃ\n");
          printf("L[Ă\n");
          mygetch();
          goto selectseed;
        }else if(itemlist[inv[enti][0]].prop!=3){
          printf("͎ł͂Ȃ\n");
          printf("L[Ă\n");
          mygetch();
          goto selectseed;
        }else{
          switch(itemlist[inv[enti][0]].num){
          case 17:
            crp[i].prop=0;
            crp[i].hrd=1;
            crp[i].planted[0]=year;
            crp[i].planted[1]=month;
            crp[i].planted[2]=day;
            crp[i].planted[3]=hour;
            break;
          case 18:
            crp[i].prop=1;
            crp[i].hrd=1;
            crp[i].planted[0]=year;
            crp[i].planted[1]=month;
            crp[i].planted[2]=day;
            crp[i].planted[3]=hour;
            break;
          }
          itemconsume(enti,1);
        }
      }else{
        printf("ȏAȂ\n");
        printf("L[Ă\n");
        mygetch();
        goto input;
      }
      break;

    case 'h'://n
    selectharv:
      system("cls");
      printf("ǂnH\n\n");
      for(j=0;j<farmlv;j++){
        if(grouth[j]==3){
          printf("%c:%s\n",alphabet[j],propname[crp[j].prop]);
        }
        ent=mygetch();
        if(ent==ESC) goto input;
        enti=alp2int(ent);
        if((enti>=farmlv)||(crp[enti].prop==-1)||(grouth[enti]!=3)){
          printf("͎nłȂ\n");
          printf("L[Ă\n");
          mygetch();
          goto selectharv;
        }else{
          switch(crp[j].prop){
          case 0:
            matnum=25;
            break;
          case 1:
            matnum=27;
            break;
          }
          for(i=0;i<maxmat;i++){
            if(mat[i][0]==matnum){
              rnd=dice(1,trpcalc(skl.plant[0],pc.lv+crp[j].hrd,2)+1,0);
              mat[i][1]=mat[i][1]+rnd;
              skl.plant[1]=skl.plant[1]-rnd;
              for(k=j;k<farmlv-1;k++){
                crp[k]=crp[k+1];
              }
              crp[farmlv-1].prop=-1;
              break;
            }
            if(mat[i][0]==-1){
              rnd=dice(1,trpcalc(skl.plant[0],pc.lv+crp[j].hrd,2)+1,0);
              mat[i][0]=matnum;
              mat[i][1]=rnd;
              skl.plant[1]=skl.plant[1]-rnd;
              for(k=j;k<farmlv-1;k++){
                crp[k]=crp[k+1];
              }
              crp[farmlv-1].prop=-1;
              break;
            }
          }
          if(i==maxmat){
            printf("ȏfނĂȂ\n");
            printf("L[Ă\n");
            mygetch();
            goto input;
          }
        }
      }
      break;
    }

    if(skl.plant[1]<0){
      printf("͔|xUP\n");
      skl.plant[0]++;
      skl.plant[1]=skl.plant[1]+skl.plant[0]*10;
    }

    timeplus();
  }
}

void dungeon(void){
  int x,y;
  int i,j;
  FILE *f;
  char ent;
  int b;
  int damage;
  int enti;
  int rnd;
  char numc[16];

  depth=1;

  createmap(0); //}bv̍쐬

  ent=0;
  while(0<depth){

    //PC,NPC,ACeȂǂ̏ꏊ}bvɏ

    for(i=0;i<numitem;i++){
      if(itm[i].inv==0){
        mi[itm[i].y][itm[i].x].sign=itm[i].sign;
        mi[itm[i].y][itm[i].x].color=itm[i].color;
      }
    }

    for(i=0;i<numnpc;i++){
      if(npc[i].hp>=0){
        mi[npc[i].y][npc[i].x].sign=npc[i].sign;
        if(npc[i].frd==-1){ //GNPC
          mi[npc[i].y][npc[i].x].color=12;
        }else if(npc[i].frd==0){ //NPC
          mi[npc[i].y][npc[i].x].color=9;
        }
      }
    }

    mi[pc.y][pc.x].sign='@';
    mi[pc.y][pc.x].color=14;

  input:
    if((rest<=0)&&(gathering[2]<=0)&&(eat[1]<=0)){
      tx=100;
      ty=100;
      draw(); //`
    }

    sprintf(message,"");

    //PC̍s

    pc.field.pow=0;
    pc.field.def=0;
    pc.field.dex=0;
    pc.field.mag=0;
    pc.field.spd=0;

    if((rest>0)||(gathering[2]>0)||(eat[1]>0)){
      ent=ENTER;
    }else{
      ent=mygetch();
    }
    switch(ent){
    case ESC:
    case 'x':
      system("cls");
      printf("{ɏIH\n");
      printf("y/n\n");
      ent=mygetch();
      if(ent=='y'){
        exit(0);
      }else{
        goto input;
      }
      break;

    case '?':
      help();
      goto input;
      break;

    case ENTER:
      break;

    case 'w':
      wearing();
      break;

    case 'F':
      printf("\nǂŒނH");

      ent=mygetch();
      switch(ent){
      case UP:
        if(map[pc.y-1][pc.x]==9){
          gathering[0]=pc.x;
          gathering[1]=pc.y-1;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͐ꂪȂ");
          strcat(message,buf);
        }
        break;
      case DOWN:
        if(map[pc.y+1][pc.x]==9){
          gathering[0]=pc.x;
          gathering[1]=pc.y+1;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͐ꂪȂ");
          strcat(message,buf);
        }
        break;
      case RIGHT:
        if(map[pc.y][pc.x+1]==9){
          gathering[0]=pc.x+1;
          gathering[1]=pc.y;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͐ꂪȂ");
          strcat(message,buf);
        }
        break;
      case LEFT:
        if(map[pc.y][pc.x-1]==9){
          gathering[0]=pc.x-1;
          gathering[1]=pc.y;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͐ꂪȂ");
          strcat(message,buf);
        }
        break;
      }
      break;

    case 'C':
      printf("\nǂ𔰍̂H");

      ent=mygetch();
      switch(ent){
      case UP:
        if(map[pc.y-1][pc.x]==6){
          gathering[0]=pc.x;
          gathering[1]=pc.y-1;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͖؂Ȃ");
          strcat(message,buf);
        }
        break;
      case DOWN:
        if(map[pc.y+1][pc.x]==6){
          gathering[0]=pc.x;
          gathering[1]=pc.y+1;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͖؂Ȃ");
          strcat(message,buf);
        }
        break;
      case RIGHT:
        if(map[pc.y][pc.x+1]==6){
          gathering[0]=pc.x+1;
          gathering[1]=pc.y;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͖؂Ȃ");
          strcat(message,buf);
        }
        break;
      case LEFT:
        if(map[pc.y][pc.x-1]==6){
          gathering[0]=pc.x-1;
          gathering[1]=pc.y;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͖؂Ȃ");
          strcat(message,buf);
        }
        break;
      }
      break;

    case 'D':
      printf("\nǂ@H");

      ent=mygetch();
      switch(ent){
      case UP:
        if((map[pc.y-1][pc.x]==4)||(map[pc.y-1][pc.x]==5)){
          gathering[0]=pc.x;
          gathering[1]=pc.y-1;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͍zȂ");
          strcat(message,buf);
        }
        break;
      case DOWN:
        if((map[pc.y+1][pc.x]==4)||(map[pc.y+1][pc.x]==5)){
          gathering[0]=pc.x;
          gathering[1]=pc.y+1;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͍zȂ");
          strcat(message,buf);
        }
        break;
      case RIGHT:
        if((map[pc.y][pc.x+1]==4)||(map[pc.y][pc.x+1]==5)){
          gathering[0]=pc.x+1;
          gathering[1]=pc.y;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͍zȂ");
          strcat(message,buf);
        }
        break;
      case LEFT:
        if((map[pc.y][pc.x-1]==4)||(map[pc.y][pc.x-1]==5)){
          gathering[0]=pc.x-1;
          gathering[1]=pc.y;
          gathering[2]=10;
        }else{
          sprintf(buf,"\nɂ͍zȂ");
          strcat(message,buf);
        }
        break;
      }
      break;

    case '*':
      targetselect();
      goto input;

    case 'r':
      system("cls");
    inputrest:
      printf("^[xeH\n");
      printf("(&őS񕜂܂)\n");
      scanf("%s",numc);
      if(numc[0]=='&'){
        i=(pc.mmp-pc.mp)*5;
        j=(pc.mhp-pc.hp)*3;
        if(i<j){
          rest=j;
        }else{
          rest=i;
        }
      }else{
        rest=numc2int(numc);
      }
      if(rest<0) goto inputrest;
      break;

    case 'd':
      drop();
      break;

    case 'g':
      if(pc.place!=11){
        sprintf(buf,"\nȂ͋C");
        strcat(message,buf);
      }else{
        for(i=0;i<numitem;i++){
          if((itm[i].inv==0)&&(itm[i].x==pc.x)&&(itm[i].y==pc.y)) break;
        }

        if(itm[i].prop==4){
          for(j=0;j<maxinv;j++){
            if(inv[j][0]==-1){
              inv[j][0]=itm[i].num;
              inv[j][1]=dice(2,trpcalc(depth,itm[i].rare+pc.lv,5)+1,0);
              itm[i].inv=1;
              pc.place=itm[i].place;
              break;
            }
          }
          if(j==maxinv){
            sprintf(buf,"\nɂȏȂ");
            strcat(message,buf);
          }else{
            sprintf(buf,"\nȂ%s(c%d)E",itemlist[inv[j][0]].name,inv[j][1]);
            strcat(message,buf);
          }
        }else{
          for(j=0;j<maxinv;j++){
            if(inv[j][0]==itm[i].num){
              inv[j][1]++;
              break;
            }
            if(inv[j][0]==-1){
              inv[j][0]=itm[i].num;
              inv[j][1]=1;
              break;
            }
          }
          if(j==maxinv){
            sprintf(buf,"\nɂȏȂ");
            strcat(message,buf);
          }else{
            pc.place=itm[i].place;
            itm[i].inv=1;
            sprintf(buf,"\nȂ%sE",itm[i].name);
            strcat(message,buf);
          }
        }
      }
      break;

    case 'T':
    chooset:
      system("cls");
      printf("𓊂?\n\n");
      for(i=0;i<maxinv;i++){
        if(inv[i][0]==-1) break;
        if(itemlist[inv[i][0]].prop==0){
          printf("%c:%s x%d\n",alphabet[i],itemlist[inv[i][0]].name,inv[i][1]);
        }
      }
      printf("\n");
      ent=mygetch();

      if(ent==ESC){
        goto input;
      }else if((inv[alp2int(ent)][0]==-1)||(maxinv<=alp2int(ent))){
        printf("̃ACe݂͑Ȃ\n");
        printf("L[Ă");
        mygetch();
        goto chooset;
      }else{
        i=alp2int(ent);
        j=targetselect();
        if(j==-1) goto chooset;
        
        if(j==10){
          if((ty==pc.y)&&(tx==pc.x)){
            if(rand()%100<75){
              sprintf(buf,"\nȂ͂Ȃ%s𓊂",itemlist[inv[i][0]].name);
              strcat(message,buf);
              useitem(inv[i][0]);
            }else{
              sprintf(buf,"\n%s͂ȂɓȂ",itemlist[inv[i][0]].name);
              strcat(message,buf);
            }
          }else{
            for(j=0;j<numnpc;j++){
              if((0<=npc[j].hp)&&(npc[j].x==tx)&&(npc[j].y==ty)) break;
            }
            if(rand()%100<trpcalc(pc.pars.dex[0]+pc.field.dex,npc[j].pars.dex[0]+npc[j].field.dex,75)){
              sprintf(buf,"\nȂ%s%s𓊂",npc[j].name,itemlist[inv[i][0]].name);
              strcat(message,buf);
              if(npc[j].frd!=0){
                npc[j].frd=-1;
                sprintf(buf,"\n%s͓{",npc[j].name);
                strcat(message,buf);
              }
              useitemnpc(inv[i][0],j);
            }else{
              sprintf(buf,"\n%s%sɓȂ",itemlist[inv[i][0]].name,npc[j].name);
              strcat(message,buf);
            }
          }
        }else if((j==0)||
                 (j==2)||
                 (j==11)){
          sprintf(buf,"\n%s͏ɗĊꂽ",itemlist[inv[i][0]].name);
          strcat(message,buf);
        }else if(j==1){
          sprintf(buf,"\n%s͕ǂɓĊꂽ",itemlist[inv[i][0]].name);
          strcat(message,buf);
        }

        itemconsume(i,1);
      }
      break;

    case 't':
    chooseq:
      system("cls");
      printf("g?\n\n");
      for(i=0;i<maxinv;i++){
        if(inv[i][0]==-1) break;
        if(itemlist[inv[i][0]].prop==4){
          printf("%c:%s(c%d)\n",alphabet[i],itemlist[inv[i][0]].name,inv[i][1]);
        }else{
          printf("%c:%s x%d\n",alphabet[i],itemlist[inv[i][0]].name,inv[i][1]);
        }
      }
      printf("\n");
      ent=mygetch();

      if(ent==ESC){
        goto input;
      }else if((inv[alp2int(ent)][0]==-1)||(maxinv<=alp2int(ent))){
        printf("̃ACe݂͑Ȃ\n");
        printf("L[Ă");
        mygetch();
        goto chooseq;
      }else{
        i=alp2int(ent);

        if(itemlist[inv[i][0]].prop==2){ //H
          eat[0]=i;
          eat[1]=10;
        }else if(itemlist[inv[i][0]].prop==4){ //@̏
          if(inv[i][1]==0){
            sprintf(buf,"\n͂cĂȂ");
            strcat(message,buf);
          }else{
            if(rand()%100<trpcalc(pc.pars.mag[0]+pc.field.mag,itemlist[inv[i][0]].rare,80)){
              switch(inv[i][0]){
              case 40:

                inv[i][1]--;
                damage=dice(3,(pc.pars.mag[0]+pc.field.mag)/2,0);
                pc.hp=pc.hp+damage;
                if(pc.mhp<pc.hp) pc.hp=pc.mhp;
                pc.mp=pc.mp-5;
                sprintf(buf,"\nȂ͌y̏U%d񕜂",damage);
                strcat(message,buf);
                break;

              case 41:

                inv[i][1]--;
                damage=dice(5,(pc.pars.mag[0]+pc.field.mag)/2,0);
                pc.hp=pc.hp+damage;
                if(pc.mhp<pc.hp) pc.hp=pc.mhp;
                pc.mp=pc.mp-10;
                sprintf(buf,"\nȂ͏d̏U%d񕜂",damage);
                strcat(message,buf);
                break;

              case 42:

                inv[i][1]--;
                damage=dice(8,(pc.pars.mag[0]+pc.field.mag)/2,0);
                pc.hp=pc.hp+damage;
                if(pc.mhp<pc.hp) pc.hp=pc.mhp;
                pc.mp=pc.mp-20;
                sprintf(buf,"\nȂ͒v̏U%d񕜂",damage);
                strcat(message,buf);
                break;

              case 43:

                inv[i][1]--;
                b=1;
                while(b==1){
                  x=5-rand()%10;
                  y=5-rand()%10;
                  if((map[pc.y+y][pc.x+x]==0)||
                     (map[pc.y+y][pc.x+x]==2)){
                    b=0;
                  }
                }
                map[pc.y][pc.x]=pc.place;
                mi[pc.y][pc.x]=chip[pc.place];
                pc.x=pc.x+x;
                pc.y=pc.y+y;
                map[pc.y][pc.x]=10;
                sprintf(buf,"\nȂ̓V[ge|[g̏U");
                strcat(message,buf);
                break;

              case 44:

                inv[i][1]--;
                b=1;
                while(b==1){
                  x=rand()%40;
                  y=rand()%40;
                  if(map[y][x]==0) b=0;
                }
                map[pc.y][pc.x]=0;
                mi[pc.y][pc.x]=chip[0];
                pc.x=x;
                pc.y=y;
                map[pc.y][pc.x]=10;
                sprintf(buf,"\nȂ̓e|[g̏U");
                strcat(message,buf);
                break;

              case 45:

                inv[i][1]--;

                i=targetselect();
                if(i==-1) goto selectmagic;

                if(i==10){
                  damage=dice(3,(pc.pars.mag[0]+pc.field.mag)/2,0);
                  if((tx==pc.x)&&(ty==pc.y)){
                    pc.hp=pc.hp-damage;
                    sprintf(buf,"\nȂ͖@̖̏U莩%d̃_[W^",damage);
                    strcat(message,buf);
                  }else{
                    for(i=0;i<numnpc;i++){
                      if((npc[i].hp>=0)&&(npc[i].x==tx)&&(npc[i].y==ty)) break;
                    }
                    npc[i].hp=npc[i].hp-damage;
                    if(npc[i].hp<0){
                      sprintf(buf,"\nȂ͖@̖̏U%s%d̃_[W^ĎE",npc[i].name,damage);
                      strcat(message,buf);
                      kill(i,tx,ty);
                    }else{
                      sprintf(buf,"\nȂ͖@̖̏U%s%d̃_[W^",npc[i].name,damage);
                      strcat(message,buf);
                      if(npc[i].frd!=0){
                        npc[i].frd=-1;
                        sprintf(buf,"\n%s͓{",npc[i].name);
                        strcat(message,buf);
                      }
                    }
                  }
                }else if(i==0){
                  sprintf(buf,"\nȂ͋ԂɌĖ@̖̏U");
                  strcat(message,buf);
                }else if(i==1){
                  sprintf(buf,"\nȂ͕ǂɌĖ@̖̏U");
                  strcat(message,buf);
                }else if(i==11){
                  for(i=0;i<numitem;i++){
                    if((itm[i].inv==0)&&(itm[i].x==tx)&&(itm[i].y==ty)) break;
                  }
                  itm[i].inv=1;
                  map[ty][tx]=itm[i].place;
                  mi[ty][tx]=chip[itm[i].place];
                  sprintf(buf,"\nnʂ%s͊ꂽ",itm[i].name);
                  strcat(message,buf);
                }
                break;

              case 46:

                inv[i][1]--;

                i=targetselect();
                if(i==-1) goto selectmagic;

                if(i==10){
                  damage=dice(5,(pc.pars.mag[0]+pc.field.mag)/2,0);
                  if((tx==pc.x)&&(ty==pc.y)){
                    pc.hp=pc.hp-damage;
                    sprintf(buf,"\nȂ̓}WbN~TC̏U莩%d̃_[W^",damage);
                    strcat(message,buf);
                  }else{
                    for(i=0;i<numnpc;i++){
                      if((npc[i].hp>=0)&&(npc[i].x==tx)&&(npc[i].y==ty)) break;
                    }
                    npc[i].hp=npc[i].hp-damage;
                    if(npc[i].hp<0){
                      sprintf(buf,"\nȂ̓}WbN~TC̏U%s%d̃_[W^ĎE",npc[i].name,damage);
                      strcat(message,buf);
                      kill(i,tx,ty);
                    }else{
                      sprintf(buf,"\nȂ̓}WbN~TC̏U%s%d̃_[W^",npc[i].name,damage);
                      strcat(message,buf);
                      if(npc[i].frd!=0){
                        npc[i].frd=-1;
                        sprintf(buf,"\n%s͓{",npc[i].name);
                        strcat(message,buf);
                      }
                    }
                  }
                }else if(i==0){
                  sprintf(buf,"\nȂ͋ԂɌă}WbN~TC̏U");
                  strcat(message,buf);
                }else if(i==1){
                  sprintf(buf,"\nȂ͕ǂɌă}WbN~TC̏U");
                  strcat(message,buf);
                }else if(i==11){
                  for(i=0;i<numitem;i++){
                    if((itm[i].inv==0)&&(itm[i].x==tx)&&(itm[i].y==ty)) break;
                  }
                  itm[i].inv=1;
                  map[ty][tx]=itm[i].place;
                  mi[ty][tx]=chip[itm[i].place];
                  sprintf(buf,"\nnʂ%s͊ꂽ",itm[i].name);
                  strcat(message,buf);
                }
                break;

              case 47:
                inv[i][1]--;
                sprintf(buf,"\nȂ͉pY̏U");
                strcat(message,buf);
                damage=dice(2,(pc.pars.mag[0]+pc.field.mag)/2,0);
                pc.pars.pow[0]=pc.par.pow+damage;
                pc.pars.dex[0]=pc.par.dex+damage;
                pc.pars.pow[1]=(pc.pars.mag[0]+pc.field.mag)/2+5;
                pc.pars.dex[1]=(pc.pars.mag[0]+pc.field.mag)/2+5;
                sprintf(buf,"\nȂ̍ÚEp%dオ",damage);
                strcat(message,buf);
                break;

              case 48:
                inv[i][1]--;
                sprintf(buf,"\nȂ͖@̏̏U");
                strcat(message,buf);
                damage=dice(2,(pc.pars.mag[0]+pc.field.mag)/2,0);
                pc.pars.def[0]=pc.par.def+damage;
                pc.pars.def[1]=(pc.pars.mag[0]+pc.field.mag)/2+5;
                sprintf(buf,"\nȂ̖h͂%dオ",damage);
                strcat(message,buf);
                break;

              case 49:
                inv[i][1]--;
                sprintf(buf,"\nȂ͌҂̏U");
                strcat(message,buf);
                damage=dice(2,(pc.pars.mag[0]+pc.field.mag)/2,0);
                pc.pars.mag[0]=pc.par.mag+damage;
                pc.pars.mag[1]=(pc.pars.mag[0]+pc.field.mag)/2+5;
                sprintf(buf,"\nȂ̖͂%dオ",damage);
                strcat(message,buf);
                break;

              case 50:
                inv[i][1]--;
                sprintf(buf,"\nȂ͏ȑU");
                damage=dice(3,(pc.pars.mag[0]+pc.field.mag),10);
                pc.pars.spd[0]=pc.par.spd+damage;
                pc.pars.spd[1]=(pc.pars.mag[0]+pc.field.mag)/2+5;
                sprintf(buf,"\nȂ̑%dオ",damage);
                strcat(message,buf);
                break;

              case 51:
                inv[i][1]--;
                sprintf(buf,"\nȂ͖͂̏U");
                damage=dice(2,(pc.pars.mag[0]+pc.field.mag)/2,5);
                pc.mp=pc.mp+damage;
                if(pc.mmp<pc.mp) pc.mp=pc.mmp;
                break;
              }
            }else{
              sprintf(buf,"Ȃ͏܂gȂ");
              strcat(message,buf);
            }
          }
        }else{
          sprintf(buf,"\nȂ%sg",itemlist[inv[i][0]].name);
          strcat(message,buf);
          useitem(inv[i][0]);
          itemconsume(i,1);
        }
      }
      break;

    case '>':
      if(pc.place==2){
        floordown(1);
        arrow=arrow+20;
        sprintf(buf,"\nȂ͊Ki~肽");
        strcat(message,buf);
      }else{
        sprintf(buf,"\nɂ͉KiȂ");
        strcat(message,buf);
      }
      break;

    case '<':
      if(pc.place==3){
        floordown(-1);
        sprintf(buf,"\nȂ͊Ki");
        strcat(message,buf);
      }else{
        sprintf(buf,"\nɂ͏KiȂ");
        strcat(message,buf);
      }
      break;

    case 'f':
      if(arrow>0){

        i=targetselect();
        if(i==-1) goto input;

        arrow--;
        if(map[ty][tx]==10){
          if((ty==pc.y)&&(tx==pc.x)){
            if(rand()%100<75){
              damage=dice(3,trpcalc(pc.pars.dex[0]+pc.field.dex,pc.pars.def[0]+pc.field.def,5),0);
              pc.hp=pc.hp-damage;
              sprintf(buf,"\nȂ͎ˌ%d̃_[W󂯂",damage);
              strcat(message,buf);
            }else{
              sprintf(buf,"\n͂ȂɓȂ");
              strcat(message,buf);
            }
          }else{
            for(i=0;i<numnpc;i++){
              if((0<=npc[i].hp)&&(npc[i].x==tx)&&(npc[i].y==ty)) break;
            }
            if(rand()%100<trpcalc(pc.pars.dex[0],npc[i].pars.dex[0]+npc[i].field.dex,75)){
              damage=dice(3,trpcalc(pc.pars.dex[0]+pc.field.dex,npc[i].pars.def[0]+npc[i].field.def,5),0);
              npc[i].hp=npc[i].hp-damage;
              if(npc[i].hp<0){
                sprintf(buf,"\nȂ%sˌ%d̃_[W^ĎE",npc[i].name,damage);
                strcat(message,buf);
                kill(i,tx,ty);
              }else{
                sprintf(buf,"\nȂ%sˌ%d̃_[W^",npc[i].name,damage);
                strcat(message,buf);
                if(npc[i].frd!=0){
                  npc[i].frd=-1;
                  sprintf(buf,"\n%s͓{",npc[i].name);
                  strcat(message,buf);
                }
              }
            }else{
              sprintf(buf,"\n%sɓȂ",npc[i].name);
              strcat(message,buf);
            }
          }
        }else if((map[ty][tx]==0)||
                 (map[ty][tx]==2)){
          sprintf(buf,"\n͏Ɏh");
          strcat(message,buf);
        }else if(map[ty][tx]==1){
          sprintf(buf,"\n͕ǂɎh");
          strcat(message,buf);
        }else if(map[ty][tx]==11){
          for(i=0;i<numitem;i++){
            if((itm[i].inv==0)&&(itm[i].x==tx)&&(itm[i].y==ty)){
              break;
            }
          }
          itm[i].inv=1;
          map[ty][tx]=itm[i].place;
          mi[ty][tx]=chip[itm[i].place];
          sprintf(buf,"\nnʂ%s͊ꂽ",itm[i].name);
          strcat(message,buf);
        }
      }else{
        sprintf(buf,"\nȂ");
        strcat(message,buf);
      }
      break;

    case 'm':
    selectmagic:
      system("cls");
      printf("̖@rH\n\n");
      for(i=0;pc.magic[i]!=-1;i++){
        printf("%c:%s(MP%d,%s,%d%%)\n",
               alphabet[i],
               magiclist[pc.magic[i]].name,
               magiclist[pc.magic[i]].mp,
               magiclist[pc.magic[i]].expl,
               trpcalc(pc.pars.mag[0]+pc.field.mag,magiclist[pc.magic[i]].hrd,80));
      }

      ent=mygetch();
      if((ent=='q')||(ent==ESC)) goto input;
      enti=alp2int(ent);
      if(pc.magic[enti]==-1){
        printf("̖@͎gȂ\n");
        printf("L[Ă");
        mygetch();
        goto selectmagic;
      }

      if(pc.mp<magiclist[pc.magic[enti]].mp){
        sprintf(buf,"\nMPȂ");
        strcat(message,buf);
      }else if(rand()%100>=trpcalc(pc.pars.mag[0]+pc.field.mag,magiclist[pc.magic[enti]].hrd,80)){
        sprintf(buf,"\nȂ%s̉rɎs",magiclist[pc.magic[enti]].name);
        strcat(message,buf);
      }else{
        switch(pc.magic[enti]){
        case 0:
          damage=dice(3,(pc.pars.mag[0]+pc.field.mag)/2,0);
          pc.hp=pc.hp+damage;
          if(pc.mhp<pc.hp) pc.hp=pc.mhp;
          pc.mp=pc.mp-5;
          sprintf(buf,"\nȂ͌y̖@%d񕜂",damage);
          strcat(message,buf);
          break;

        case 1:
          damage=dice(5,(pc.pars.mag[0]+pc.field.mag)/2,0);
          pc.hp=pc.hp+damage;
          if(pc.mhp<pc.hp) pc.hp=pc.mhp;
          pc.mp=pc.mp-10;
          sprintf(buf,"\nȂ͏d̖@%d񕜂",damage);
          strcat(message,buf);
          break;

        case 2:
          damage=dice(8,(pc.pars.mag[0]+pc.field.mag)/2,0);
          pc.hp=pc.hp+damage;
          if(pc.mhp<pc.hp) pc.hp=pc.mhp;
          pc.mp=pc.mp-20;
          sprintf(buf,"\nȂ͒v̖@%d񕜂",damage);
          strcat(message,buf);
          break;

        case 3:
          pc.mp=pc.mp-5;
          b=1;
          while(b==1){
            x=5-rand()%10;
            y=5-rand()%10;
            if((map[pc.y+y][pc.x+x]==0)||
               (map[pc.y+y][pc.x+x]==2)){
              b=0;
            }
          }
          map[pc.y][pc.x]=pc.place;
          mi[pc.y][pc.x]=chip[pc.place];
          pc.x=pc.x+x;
          pc.y=pc.y+y;
          map[pc.y][pc.x]=10;
          sprintf(buf,"\nȂ̓V[ge|[g̖@");
          strcat(message,buf);
          break;

        case 4:
          pc.mp=pc.mp-10;
          b=1;
          while(b==1){
            x=rand()%40;
            y=rand()%40;
            if(map[y][x]==0) b=0;
          }
          map[pc.y][pc.x]=0;
          mi[pc.y][pc.x]=chip[0];
          pc.x=x;
          pc.y=y;
          map[pc.y][pc.x]=10;
          sprintf(buf,"\nȂ̓e|[g̖@");
          strcat(message,buf);
          break;

        case 5:

          i=targetselect();
          if(i==-1) goto selectmagic;

          pc.mp=pc.mp-5;
          if(i==10){
            damage=dice(3,(pc.pars.mag[0]+pc.field.mag)/2,0);
            if((tx==pc.x)&&(ty==pc.y)){
              pc.hp=pc.hp-damage;
              sprintf(buf,"\nȂ͖@̖r%d̃_[W^",damage);
              strcat(message,buf);
            }else{
              for(i=0;i<numnpc;i++){
                if((npc[i].hp>=0)&&(npc[i].x==tx)&&(npc[i].y==ty)) break;
              }
              npc[i].hp=npc[i].hp-damage;
              if(npc[i].hp<0){
                sprintf(buf,"\nȂ͖@̖r%s%d̃_[W^ĎE",npc[i].name,damage);
                strcat(message,buf);
                kill(i,tx,ty);
              }else{
                sprintf(buf,"\nȂ͖@̖r%s%d̃_[W^",npc[i].name,damage);
                strcat(message,buf);
                if(npc[i].frd!=0){
                  npc[i].frd=-1;
                  sprintf(buf,"\n%s͓{",npc[i].name);
                  strcat(message,buf);
                }
              }
            }
          }else if(i==0){
            sprintf(buf,"\nȂ͋ԂɌĖ@̖r");
            strcat(message,buf);
          }else if(i==1){
            sprintf(buf,"\nȂ͕ǂɌĖ@̖r");
            strcat(message,buf);
          }else if(i==11){
            for(i=0;i<numitem;i++){
              if((itm[i].inv==0)&&(itm[i].x==tx)&&(itm[i].y==ty)) break;
            }
            itm[i].inv=1;
            map[ty][tx]=itm[i].place;
            mi[ty][tx]=chip[itm[i].place];
            sprintf(buf,"\nnʂ%s͊ꂽ",itm[i].name);
            strcat(message,buf);
          }
          break;

        case 6:

          i=targetselect();
          if(i==-1) goto selectmagic;

          pc.mp=pc.mp-5;
          if(i==10){
            damage=dice(5,(pc.pars.mag[0]+pc.field.mag)/2,0);
            if((tx==pc.x)&&(ty==pc.y)){
              pc.hp=pc.hp-damage;
              sprintf(buf,"\nȂ̓}WbN~TCr%d̃_[W^",damage);
              strcat(message,buf);
            }else{
              for(i=0;i<numnpc;i++){
                if((npc[i].hp>=0)&&(npc[i].x==tx)&&(npc[i].y==ty)) break;
              }
              npc[i].hp=npc[i].hp-damage;
              if(npc[i].hp<0){
                sprintf(buf,"\nȂ̓}WbN~TCr%s%d̃_[W^ĎE",npc[i].name,damage);
                strcat(message,buf);
                kill(i,tx,ty);
              }else{
                sprintf(buf,"\nȂ̓}WbN~TCr%s%d̃_[W^",npc[i].name,damage);
                strcat(message,buf);
                if(npc[i].frd!=0){
                  npc[i].frd=-1;
                  sprintf(buf,"\n%s͓{",npc[i].name);
                  strcat(message,buf);
                }
              }
            }
          }else if(i==0){
            sprintf(buf,"\nȂ͋ԂɌă}WbN~TCr");
            strcat(message,buf);
          }else if(i==1){
            sprintf(buf,"\nȂ͕ǂɌă}WbN~TCr");
            strcat(message,buf);
          }else if(i==11){
            for(i=0;i<numitem;i++){
              if((itm[i].inv==0)&&(itm[i].x==tx)&&(itm[i].y==ty)) break;
            }
            itm[i].inv=1;
            map[ty][tx]=itm[i].place;
            mi[ty][tx]=chip[itm[i].place];
            sprintf(buf,"\nnʂ%s͊ꂽ",itm[i].name);
            strcat(message,buf);
          }
          break;

        case 7:
          pc.mp=pc.mp-30;
          sprintf(buf,"\nȂ͖̗͂r");
          strcat(message,buf);
          for(ty=pc.y-2;ty<=pc.y+2;ty++){
            for(tx=pc.x-2;tx<=pc.x+2;tx++){
              if(map[ty][tx]==10){
                if((ty==pc.y)&&(tx==pc.x)){
                }else{
                  for(i=0;i<numnpc;i++){
                    if(0<=npc[i].hp){
                      if((ty==npc[i].y)&&(tx==npc[i].x)){
                        damage=dice(5,(pc.pars.mag[0]+pc.field.mag)/2,0);
                        npc[i].hp=npc[i].hp-damage;
                        if(0<=npc[i].hp){
                          sprintf(buf,"\n%s%d̃_[W^",npc[i].name,damage);
                          strcat(message,buf);
                          if(npc[i].frd!=0){
                            npc[i].frd=-1;
                            sprintf(buf,"\n%s͓{",npc[i].name);
                            strcat(message,buf);
                          }
                        }else{
                          sprintf(buf,"\n%s%d̃_[W^E",npc[i].name,damage);
                          kill(i,tx,ty);
                          strcat(message,buf);
                        }
                      }
                    }
                  }
                }
              }
              if(map[ty][tx]==11){
                if((ty==pc.y)&&(tx==pc.x)){
                }else{
                  for(i=0;i<numitem;i++){
                    if(0==itm[i].inv){
                      if((ty==itm[i].y)&&(tx==itm[i].x)){
                        itm[i].inv=1;
                        map[y][x]=itm[i].place;
                        mi[y][x]=chip[itm[i].place];
                        sprintf(buf,"\nnʂ%s͊ꂽ",itm[i].name);
                        strcat(message,buf);
                      }
                    }
                  }
                }
              }
            }
          }
          break;

        case 8:
          pc.mp=pc.mp-10;
          sprintf(buf,"\nȂ͉pYr");
          strcat(message,buf);
          damage=dice(2,(pc.pars.mag[0]+pc.field.mag)/2,0);
          pc.pars.pow[0]=pc.par.pow+damage;
          pc.pars.dex[0]=pc.par.dex+damage;
          pc.pars.pow[1]=(pc.pars.mag[0]+pc.field.mag)/2+5;
          pc.pars.dex[1]=(pc.pars.mag[0]+pc.field.mag)/2+5;
          sprintf(buf,"\nȂ̍ÚEp%dオ",damage);
          strcat(message,buf);
          break;

        case 9:
          pc.mp=pc.mp-10;
          sprintf(buf,"\nȂ͖@̏r");
          strcat(message,buf);
          damage=dice(2,(pc.pars.mag[0]+pc.field.mag)/2,0);
          pc.pars.def[0]=pc.par.def+damage;
          pc.pars.def[1]=(pc.pars.mag[0]+pc.field.mag)/2+5;
          sprintf(buf,"\nȂ̖h͂%dオ",damage);
          strcat(message,buf);
          break;

        case 10:
          pc.mp=pc.mp-10;
          sprintf(buf,"\nȂ͌҂r");
          strcat(message,buf);
          damage=dice(2,(pc.pars.mag[0]+pc.field.mag)/2,0);
          pc.pars.mag[0]=pc.par.mag+damage;
          pc.pars.mag[1]=(pc.pars.mag[0]+pc.field.mag)/2+5;
          sprintf(buf,"\nȂ̖͂%dオ",damage);
          strcat(message,buf);
          break;

        case 11:
          pc.mp=pc.mp-10;
          sprintf(buf,"\nȂ͏rr");
          damage=dice(3,(pc.pars.mag[0]+pc.field.mag),10);
          pc.pars.spd[0]=pc.par.spd+damage;
          pc.pars.spd[1]=(pc.pars.mag[0]+pc.field.mag)/2+5;
          sprintf(buf,"\nȂ̑%dオ",damage);
          strcat(message,buf);
          break;
        }
      }
      break;

    case UP:
      pcmove(0,-1);
      break;

    case DOWN:
      pcmove(0,1);
      break;

    case RIGHT:
      pcmove(1,0);
      break;

    case LEFT:
      pcmove(-1,0);
      break;
    }

    if(rest>0){
      rest--;
      if(rest==0){
        sprintf(buf,"\nȂ͋xeI");
        strcat(message,buf);
      }
    }
    if(gathering[2]>0){
      gathering[2]--;
      if(gathering[2]==0){
        gather(gathering[0],gathering[1]);
      }
    }
    if(tohouse>0){
      tohouse--;
      if(tohouse==0){
        floordown(-depth);
      }
    }
    if(eat[1]>0){
      eat[1]--;
      if(eat[1]==0){
        pc.stm=pc.stm+300;
        if(pc.stm>1000) pc.stm=1000;
        useitem(inv[eat[0]][0]);
        itemconsume(eat[0],1);
        sprintf(buf,"\nȂ%sH׏I",itemlist[inv[eat[0]][0]].name);
      }
    }
    pc.rec++;
    if(pc.rec%5==0){
      if(pc.mmp>pc.mp) pc.mp++;
    }
    if(pc.rec%3==0){
      if(pc.mhp>pc.hp) pc.hp++;
    }

    //NPC̍s
    for(i=0;i<numnpc;i++){
      npc[i].field.pow=0;
      npc[i].field.def=0;
      npc[i].field.dex=0;
      npc[i].field.mag=0;
      npc[i].field.spd=0;

      if(npc[i].hp>=0){ 
        npc[i].turn=npc[i].turn-(double)(npc[i].pars.spd[0]+npc[i].field.spd)/(double)(pc.pars.spd[0]+pc.field.spd);
        while(npc[i].turn<0){
          if(npc[i].frd==0){
            randwalk(i);
          }else if(npc[i].frd==-1){
            if(npc[i].ai==0){ //ߐAI
              if((ab(pc.x-npc[i].x)<excite)&&(ab(pc.y-npc[i].y)<excite)){
                if(ab(pc.x-npc[i].x)<ab(pc.y-npc[i].y)){
                  if(pc.y<npc[i].y){
                    npcmove(i,0,-1);
                  }else{
                    npcmove(i,0,1);
                  }
                }else{
                  if(pc.x<npc[i].x){
                    npcmove(i,-1,0);
                  }else{
                    npcmove(i,1,0);
                  }
                }
              }else{
                randwalk(i);
              }
            }else if(npc[i].ai==1){ //@AI
              if((ab(pc.x-npc[i].x)<excite)&&(ab(pc.y-npc[i].y)<excite)){
                if((rand()%100<30)&&(ab(pc.x-npc[i].x)<=5)&&(ab(pc.y-npc[i].y)<=5)){
                  enti=rand()%(depth/3+1);
                  if(npc[i].mp<magiclist[npcmagic[enti]].mp){
                    sprintf(buf,"\n%s%sr悤ƂMPȂ",npc[i].name,magiclist[npcmagic[enti]].name);
                    strcat(message,buf);
                  }else if(rand()%100>=trpcalc(npc[i].pars.mag[0]+npc[i].field.mag,magiclist[npcmagic[enti]].hrd,80)){
                    sprintf(buf,"\n%s%s̉rɎs",npc[i].name,magiclist[npcmagic[enti]].name);
                    strcat(message,buf);
                  }else{
                    switch(npcmagic[enti]){
                    case 0:
                      npc[i].mp=npc[i].mp-5;
                      damage=dice(3,(npc[i].pars.mag[0]+npc[i].field.mag)/2,0);
                      npc[i].hp=npc[i].hp+damage;
                      if(npc[i].mhp<npc[i].hp) npc[i].hp=npc[i].mhp;
                      sprintf(buf,"\n%s͌yr%d񕜂",npc[i].name,damage);
                      strcat(message,buf);
                      break;
                    case 1:
                      npc[i].mp=npc[i].mp-5;
                      b=1;
                      while(b==1){
                        x=5-rand()%10;
                        y=5-rand()%10;
                        if((map[npc[i].y+y][npc[i].x+x]==0)||
                         (map[npc[i].y+y][npc[i].x+x]==2)){
                          b=0;
                        }
                      }
                      map[npc[i].y][npc[i].x]=npc[i].place;
                      mi[npc[i].y][npc[i].x]=chip[npc[i].place];
                      npc[i].x=npc[i].x+x;
                      npc[i].y=npc[i].y+y;
                      map[npc[i].y][npc[i].x]=10;
                      sprintf(buf,"\n%s̓V[ge|[gr",npc[i].name);
                      strcat(message,buf);
                      break;
                    case 2:
                      npc[i].mp=npc[i].mp-5;
                      damage=dice(2,(npc[i].pars.mag[0]+npc[i].field.mag)/2,0);
                      pc.hp=pc.hp-damage;
                      rest=0;
                      gathering[2]=0;
                      eat[1]=0;
                      sprintf(buf,"\n%s͖@̖rȂ%d̃_[W^",npc[i].name,damage);
                      strcat(message,buf);
                    }
                    break;
                  }
                }else{
                  if(ab(pc.x-npc[i].x)+ab(pc.y-npc[i].y)<3){
                    if(ab(pc.x-npc[i].x)<ab(pc.y-npc[i].y)){
                      if(pc.y<npc[i].y){
                        npcmove(i,0,1);
                      }else{
                        npcmove(i,0,-1);
                      }
                    }else{
                      if(pc.x<npc[i].x){
                        npcmove(i,1,0);
                      }else{
                        npcmove(i,-1,0);
                      }
                    }
                  }else{
                    if(ab(pc.x-npc[i].x)<ab(pc.y-npc[i].y)){
                      if(pc.y<npc[i].y){
                        npcmove(i,0,-1);
                      }else{
                        npcmove(i,0,1);
                      }
                    }else{
                      if(pc.x<npc[i].x){
                        npcmove(i,-1,0);
                      }else{
                        npcmove(i,1,0);
                      }
                    }
                  }
                }
              }else{
                randwalk(i);
              }
            }else if(npc[i].ai==2){ //|[VAI
              if((ab(pc.x-npc[i].x)<excite)&&(ab(pc.y-npc[i].y)<excite)){
                if(ab(pc.x-npc[i].x)+ab(pc.y-npc[i].y)<3){
                  if(ab(pc.x-npc[i].x)<ab(pc.y-npc[i].y)){
                    if(pc.y<npc[i].y){
                      npcmove(i,0,1);
                    }else{
                      npcmove(i,0,-1);
                    }
                  }else{
                    if(pc.x<npc[i].x){
                      npcmove(i,1,0);
                    }else{
                      npcmove(i,-1,0);
                    }
                  }
                }else if((ab(pc.x-npc[i].x)<5)&&(ab(pc.y-npc[i].y)<5)){
                  b=1;
                  while(b==1){
                    rnd=rand()%(sizeof itemlist/sizeof itemlist[0]);
                    if(itemlist[rnd].rare!=0){
                      if(rand()%itemlist[rnd].rare==0) b=0;
                      if(itemlist[rnd].prop!=0) b=1;
                    }
                  }
                  if(rand()%100<trpcalc(npc[i].pars.dex[0]+npc[i].field.dex,pc.pars.dex[0]+pc.field.dex,75)){
                    sprintf(buf,"\n%s͂Ȃ%s𓊂",npc[i].name,itemlist[rnd].name);
                    strcat(message,buf);
                    rest=0;
                    gathering[2];
                    eat[1]=0;
                    useitem(rnd);
                  }else{
                    sprintf(buf,"\n%s͂Ȃ%s𓊂Ȃɂ͓Ȃ",npc[i].name,itemlist[rnd].name);
                    strcat(message,buf);
                  }
                }else{
                  if(ab(pc.x-npc[i].x)<ab(pc.y-npc[i].y)){
                    if(pc.y<npc[i].y){
                      npcmove(i,0,-1);
                    }else{
                      npcmove(i,0,1);
                    }
                  }else{
                    if(pc.x<npc[i].x){
                      npcmove(i,-1,0);
                    }else{
                      npcmove(i,1,0);
                    }
                  }
                }
              }else{
                randwalk(i);
              }
            }
          }

          if(0<npc[i].pars.pow[1]){
            npc[i].pars.pow[1]--;
            if(npc[i].pars.pow[1]==0) npc[i].pars.pow[0]=npc[i].par.pow;
          }
          if(0<npc[i].pars.def[1]){
            npc[i].pars.def[1]--;
            if(npc[i].pars.def[1]==0) npc[i].pars.def[0]=npc[i].par.def;
          }
          if(0<npc[i].pars.dex[1]){
            npc[i].pars.dex[1]--;
            if(npc[i].pars.dex[1]==0) npc[i].pars.dex[0]=npc[i].par.dex;
          }
          if(0<npc[i].pars.mag[1]){
            npc[i].pars.mag[1]--;
            if(npc[i].pars.mag[1]==0) npc[i].pars.mag[0]=npc[i].par.mag;
          }
          if(0<npc[i].pars.spd[1]){
            npc[i].pars.spd[1]--;
            if(npc[i].pars.spd[1]==0) npc[i].pars.spd[0]=npc[i].par.spd;
          }

          npc[i].rec++;
          if(npc[i].rec%5==0){
            if(npc[i].mp<npc[i].mmp) npc[i].mp++;
          }
          if(npc[i].rec%3==0){
            if(npc[i].hp<npc[i].mhp) npc[i].hp++;
          }
          npc[i].turn++;
        }
      }
    }

    //Wv
    if(0<pc.pars.pow[1]){
      pc.pars.pow[1]--;
      if(pc.pars.pow[1]==0) pc.pars.pow[0]=pc.par.pow;
    }
    if(0<pc.pars.def[1]){
      pc.pars.def[1]--;
      if(pc.pars.def[1]==0) pc.pars.def[0]=pc.par.def;
    }
    if(0<pc.pars.dex[1]){
      pc.pars.dex[1]--;
      if(pc.pars.dex[1]==0) pc.pars.dex[0]=pc.par.dex;
    }
    if(0<pc.pars.mag[1]){
      pc.pars.mag[1]--;
      if(pc.pars.mag[1]==0) pc.pars.mag[0]=pc.par.mag;
    }
    if(0<pc.pars.spd[1]){
      pc.pars.spd[1]--;
      if(pc.pars.spd[1]==0) pc.pars.spd[0]=pc.par.spd;
    }

    if(stayfloor==pc.rec){
      sprintf(buf,"\nȂ͉̊Kɗ");
      strcat(message,buf);
      floordown(1);
      pc.hp=pc.hp-100;
    }if(stayfloor-30<pc.rec){
      sprintf(buf,"\nCl߂Ă");
      strcat(message,buf);
      rest=0;
      gathering[2]=0;
      eat[1]=0;
    }else if(stayfloor<100){
      sprintf(buf,"\nȂ񂾂Ȋ");
      strcat(message,buf);
    }

    sprintf(para,"U:%d h:%d p:%d :%d :%d",
            pc.pars.pow[0]+pc.field.pow,
            pc.pars.def[0]+pc.field.def,
            pc.pars.dex[0]+pc.field.dex,
            pc.pars.mag[0]+pc.field.mag,
            pc.pars.spd[0]+pc.field.spd);
    sprintf(status,"Lv:%d HP:%d/%d MP:%d/%d :%d Lv܂%d",pc.lv,pc.hp,pc.mhp,pc.mp,pc.mmp,arrow,100-pc.exp);

    timeplus();
    if(pc.hp<0) dead();

  }
}

int dice(a,b,c){
  int i,ans=0;

  for(i=0;i<a;i++) ans=ans+rand()%b+1;
  return ans+c;
}

void help(void){
  system("cls");
  printf("L[Fړ\n");
  printf("fFˌ(L[Et܂enterőΏۂm)\n");
  printf("mF@\n");
  printf("gFACeE\n");
  printf("TFACe𓊂(L[Et܂enterőΏۂm)\n");
  printf("tFACeg\n");
  printf("dFACêĂ\n");
  printf(">FKi~(Kił̂)\n");
  printf("?Fwv\n");
  printf("xFI\n\n");
  printf("L[Ă\n");
  mygetch();
}

int ab(x){
  if(x<0) return -x;
  return x;
}

int alp2int(char c){
  int i;

  for(i=0;i<26;i++){
    if(c==alphabet[i]) break;
  }

  return i;
}

int trpcalc(y,x,p){
  int ans;

  x++;
  y++;

  if(x<y){
    ans=100-50*x/y;
  }else{
    ans=50*y/x;
  }

  return ans*p/50;
}

void pcmove(x,y){
  int damage;
  int i;

  if((map[pc.y+y][pc.x+x]==0)||
     (map[pc.y+y][pc.x+x]==2)||
     (map[pc.y+y][pc.x+x]==3)||
     (map[pc.y+y][pc.x+x]==7)||
     (map[pc.y+y][pc.x+x]==8)||
     (map[pc.y+y][pc.x+x]==11)){
    map[pc.y][pc.x]=pc.place;
    mi[pc.y][pc.x]=chip[pc.place];
    pc.x=pc.x+x;
    pc.y=pc.y+y;
    pc.place=map[pc.y][pc.x];
    map[pc.y][pc.x]=10;
    switch(pc.place){
    case 7:
    case 8:
      pc.field.spd=-30;
      break;
    case 11:
      for(i=0;i<numitem;i++){
        if(itm[i].inv==0){
          if((itm[i].x==pc.x)&&(itm[i].y==pc.y)) break;
        }
      }
      sprintf(buf,"\n%s",itm[i].name);
      strcat(message,buf);
      break;
    case 2:
      sprintf(buf,"\nȂ͉Kȉɂ");
      strcat(message,buf);
      break;
    case 3:
      sprintf(buf,"\nȂ͏Kȉɂ");
      strcat(message,buf);
      break;
    }
  }else if(map[pc.y+y][pc.x+x]==1){
    sprintf(buf,"\nȂ͕ǂɂԂ");
    strcat(message,buf);
  }else if(map[pc.y+y][pc.x+x]==10){
    for(i=0;i<numnpc;i++){
      if((pc.y+y==npc[i].y)&&(pc.x+x==npc[i].x)) break;
    }
    if(npc[i].frd==-1){
      if(rand()%100<trpcalc(pc.pars.dex[0]+pc.field.dex,npc[i].pars.dex[0],90)){
        damage=dice(3,trpcalc(pc.pars.pow[0]+pc.field.pow,npc[i].pars.def[0],5),0);
        npc[i].hp=npc[i].hp-damage;
        if(npc[i].hp<0){
          sprintf(buf,"\nȂ%s%d̃_[W^ĎE",npc[i].name,damage);
          strcat(message,buf);
          kill(i,pc.x+x,pc.y+y);
        }else{
          sprintf(buf,"\nȂ%s%d̃_[W^",npc[i].name,damage);
          strcat(message,buf);
        }
      }else{
        sprintf(buf,"\n%s͂Ȃ̍U킵",npc[i].name);
        strcat(message,buf);
      }
    }else{
      pc.x=pc.x+x;
      pc.y=pc.y+y;
      npc[i].x=npc[i].x-x;
      npc[i].y=npc[i].y-y;
      sprintf(buf,"\nȂ%sƓւ",npc[i].name);
      strcat(message,buf);
    }
  }
}

void npcmove(i,x,y){
  int damage;

  if((map[npc[i].y+y][npc[i].x+x]==0)||
     (map[npc[i].y+y][npc[i].x+x]==2)||
     (map[npc[i].y+y][npc[i].x+x]==3)||
     (map[npc[i].y+y][npc[i].x+x]==7)||
     (map[npc[i].y+y][npc[i].x+x]==8)||
     (map[npc[i].y+y][npc[i].x+x]==11)){
    map[npc[i].y][npc[i].x]=npc[i].place;
    mi[npc[i].y][npc[i].x]=chip[npc[i].place];
    npc[i].x=npc[i].x+x;
    npc[i].y=npc[i].y+y;
    npc[i].place=map[npc[i].y][npc[i].x];
    map[npc[i].y][npc[i].x]=10;
    if((npc[i].place==7)||(npc[i].place==8)) npc[i].field.spd=-30;
  }else if((npc[i].y+y==pc.y)&&(npc[i].x+x==pc.x)){
    if(npc[i].frd==-1){
      if(rand()%100<trpcalc(npc[i].par.dex,pc.par.dex,90)){
        damage=dice(3,trpcalc(npc[i].par.pow,pc.par.def,5),0);
        pc.hp=pc.hp-damage;
        sprintf(buf,"\nȂ%sɉ%d̃_[W󂯂",npc[i].name,damage);
        strcat(message,buf);
      }else{
        sprintf(buf,"\nȂ%s̍U킵",npc[i].name);
        strcat(message,buf);
      }
      rest=0;
      gathering[2]=0;
      eat[1]=0;
    }
  }
}

void draw(void){
  int x,y;
  int tcolor,bgcolor;
  int attr;
  HANDLE handle;
  CONSOLE_SCREEN_BUFFER_INFO csbi;

  handle = GetStdHandle(STD_OUTPUT_HANDLE);
  GetConsoleScreenBufferInfo(handle, &csbi);

  system("cls");
  for(y=pc.y-7;y<pc.y+7;y++){
    for(x=pc.x-10;x<pc.x+10;x++){
      if((x==tx)&&(y==ty)){
        bgcolor=7;
      }else{
        bgcolor=0;
      }
      if((x<0)||(y<0)||(40<=x)||(40<=y)){
        tcolor=15;
        attr=bgcolor*16+tcolor;
        SetConsoleTextAttribute(handle,attr);
        printf("# ");
      }else{
        tcolor=mi[y][x].color;
        attr=bgcolor*16+tcolor;
        SetConsoleTextAttribute(handle,attr);
        printf("%c ",mi[y][x].sign);
      }
    }
    if(y==pc.y-10){
      bgcolor=0;
      tcolor=15;
      attr=bgcolor*16+tcolor;
      SetConsoleTextAttribute(handle,attr);
      printf("\t%dN %d %d %d %d",year,month+1,day+1,hour,min/100);
    }
    if(y==pc.y-9){
      bgcolor=0;
      tcolor=15;
      attr=bgcolor*16+tcolor;
      SetConsoleTextAttribute(handle,attr);
      printf("\tn%dK",depth);
    }
    if(y==pc.y-8){
      bgcolor=0;
      if(pc.stm==0){
        tcolor=12;
        attr=bgcolor*16+tcolor;
        SetConsoleTextAttribute(handle,attr);
        printf("\t쎀");
      }else if(pc.stm<50){
        tcolor=12;
        attr=bgcolor*16+tcolor;
        SetConsoleTextAttribute(handle,attr);
        printf("\tQ");
      }else if(pc.stm<150){
        tcolor=14;
        attr=bgcolor*16+tcolor;
        SetConsoleTextAttribute(handle,attr);
        printf("\t");
      }else if(pc.stm<300){
        tcolor=15;
        attr=bgcolor*16+tcolor;
        SetConsoleTextAttribute(handle,attr);
        printf("\t");
      }
    }
    printf("\n");
  }
  bgcolor=0;
  tcolor=15;
  SetConsoleTextAttribute(handle,bgcolor*16+tcolor);
  printf("%s\n",para);
  printf("%s\n",status);
  if(0<pc.pars.pow[1]){
    if(pc.par.pow<pc.pars.pow[0]){
      SetConsoleTextAttribute(handle,14);
      printf("UUP:%d ",pc.pars.pow[1]);
    }else{
      SetConsoleTextAttribute(handle,13);
      printf("UDOWN:%d ",pc.pars.pow[1]);
    }
  }
  if(0<pc.pars.def[1]){
    if(pc.par.def<pc.pars.def[0]){
      SetConsoleTextAttribute(handle,14);
      printf("hUP:%d ",pc.pars.def[1]);
    }else{
      SetConsoleTextAttribute(handle,13);
      printf("hDOWN:%d ",pc.pars.def[1]);
    }
  }
  if(0<pc.pars.dex[1]){
    if(pc.par.dex<pc.pars.dex[0]){
      SetConsoleTextAttribute(handle,14);
      printf("pUP:%d ",pc.pars.dex[1]);
    }else{
      SetConsoleTextAttribute(handle,13);
      printf("pDOWN:%d ",pc.pars.dex[1]);
    }
  }
  if(0<pc.pars.mag[1]){
    if(pc.par.mag<pc.pars.mag[0]){
      SetConsoleTextAttribute(handle,14);
      printf("UP:%d ",pc.pars.mag[1]);
    }else{
      SetConsoleTextAttribute(handle,13);
      printf("DOWN:%d ",pc.pars.mag[1]);
    }
  }
  if(0<pc.pars.spd[1]){
    if(pc.par.spd<pc.pars.spd[0]){
      SetConsoleTextAttribute(handle,14);
      printf("UP:%d ",pc.pars.spd[1]);
    }else{
      SetConsoleTextAttribute(handle,13);
      printf("DOWN:%d ",pc.pars.spd[1]);
    }
  }
  SetConsoleTextAttribute(handle,15);
  putmes();
}

void createmap(){
  char mapname[32];
  FILE* f;
  int x,y;
  int b;
  int i;
  int rnd;

  //}bvǂݍ
  switch(dun){
  case 0:
    i=rand()%6;
    sprintf(mapname,"map/mine/map%d",i);
    break;
  case 1:
    i=rand()%6;
    sprintf(mapname,"map/forest/map%d",i);
    break;
  case 2:
    i=rand()%6;
    sprintf(mapname,"map/sea/map%d",i);
    break;
  }
  f=fopen(mapname,"r");
  for(y=0;y<40;y++){
    for(x=0;x<40;x++){
      fscanf(f,"%d",&i);
      map[y][x]=i;
      mi[y][x]=chip[i];
    }
  }
  fclose(f);

  //PC,NPC,ACeȂǂ̏ꏊ

  for(i=0;i<numitem;i++){
    b=1;
    while(b==1){
      rnd=rand()%(sizeof itemlist/sizeof itemlist[0]);
      if(itemlist[rnd].rare==0){
        b=1;
      }else if(rand()%itemlist[rnd].rare==0){
        b=0;
        itm[i]=itemlist[rnd];
      }
    }

    b=1;
    while(b==1){
      itm[i].x=rand()%40;
      itm[i].y=rand()%40;
      if(map[itm[i].y][itm[i].x]==0){
        b=0;
      }
    }
    itm[i].place=map[itm[i].y][itm[i].x];
    map[itm[i].y][itm[i].x]=11;
  }

  b=1;
  while(b==1){
    pc.x=rand()%40;
    pc.y=rand()%40;
    if((map[pc.y][pc.x]==0)||
       (map[pc.y][pc.x]==2)||
       (map[pc.y][pc.x]==3)||
       (map[pc.y][pc.x]==7)||
       (map[pc.y][pc.x]==8)||
       (map[pc.y][pc.x]==11)){
      b=0;
    }
  }
  pc.place=map[pc.y][pc.x];
  map[pc.y][pc.x]=10;

  for(i=0;i<numnpc;i++){
    b=1;
    while(b==1){
      switch(dun){
      case 0:
        rnd=rand()%(sizeof minenpc/sizeof minenpc[0]);
        if(minenpc[rnd].rare==0){
          b=1;
        }else if(rand()%minenpc[rnd].rare==0){
          b=0;
          npc[i]=minenpc[rnd];
        }
        break;
      case 1:
        rnd=rand()%(sizeof forestnpc/sizeof forestnpc[0]);
        if(forestnpc[rnd].rare==0){
          b=1;
        }else if(rand()%forestnpc[rnd].rare==0){
          b=0;
          npc[i]=forestnpc[rnd];
        }
        break;
      case 2:
        rnd=rand()%(sizeof seanpc/sizeof seanpc[0]);
        if(seanpc[rnd].rare==0){
          b=1;
        }else if(rand()%seanpc[rnd].rare==0){
          b=0;
          npc[i]=seanpc[rnd];
        }
        break;
      }
    }

    b=1;
    while(b==1){
      npc[i].x=rand()%40;
      npc[i].y=rand()%40;
      if((map[npc[i].y][npc[i].x]==0)||
         (map[npc[i].y][npc[i].x]==2)||
         (map[npc[i].y][npc[i].x]==3)||
         (map[npc[i].y][npc[i].x]==7)||
         (map[npc[i].y][npc[i].x]==8)||
         (map[npc[i].y][npc[i].x]==11)){
        b=0;
      }
    }
    npc[i].place=map[npc[i].y][npc[i].x];
    map[npc[i].y][npc[i].x]=10;
  }
}

void dead(void){
  time_t timer;
  struct tm* date;
  char datestr[64];
  FILE* f;

  strcat(buf,"\nȂ͎");
  strcat(message,buf);

  putch('\n');
  putmes();

  timer=time(NULL);
  date=localtime(&timer);
  strftime(datestr,63,"%YN%m%d %H%M",date);

  f=fopen("dead.txt","a");
  fprintf(f,"%s\n",datestr);
  fprintf(f,"O:%s Lv:%d\n",pc.name,pc.lv);
  fprintf(f,"n%dKŎS\n",depth);
  switch(numnpc){
  case 16:
    fprintf(f,"[h:easy\n\n");
    break;
  case 32:
    fprintf(f,"[h:normal\n\n");
    break;
  case 64:
    fprintf(f,"[h:hard\n\n");
    break;
  case 128:
    fprintf(f,"[h:lunatic\n\n");
    break;
  }
  fclose(f);

  printf("\n\nL[Ă");
  mygetch();

  exit(0);
}

int targetmove(p,t,m){

  if((t+m<0)||(39<t+m)){
    sprintf(message,"}bv͈͊O");
  }else if((t+m<p-5)||(p+5<t+m)){
    sprintf(message,"˒͈͊O");
  }else{
    sprintf(message,"");
    t=t+m;
  }
  return t;
}

int targetinfo(void){
  int i;

  if(map[ty][tx]==0){
  }else if((pc.x==tx)&&(pc.y==ty)){
    sprintf(buf,"\nɂ͂Ȃ");
  }else if(map[ty][tx]==1){
    sprintf(buf,"\nɂ͕ǂ");
  }else if(map[ty][tx]==2){
    sprintf(buf,"\nɂ͉Ki");
  }else if(map[ty][tx]==3){
    sprintf(buf,"\nɂ͏Ki");
  }else if(map[ty][tx]==4){
    sprintf(buf,"\nɂ͋̍z");
  }else if(map[ty][tx]==5){
    sprintf(buf,"\nɂ͕΂̍z");
  }else if(map[ty][tx]==6){
    sprintf(buf,"\nɂ͖؂");
  }else if(map[ty][tx]==10){
    for(i=0;i<numnpc;i++){
      if(0<=npc[i].hp){
        if((tx==npc[i].x)&&(ty==npc[i].y)) break;
      }
    }
    sprintf(buf,"\nɂ%s",npc[i].name);
  }else if(map[ty][tx]==11){
    for(i=0;i<numitem;i++){
      if(itm[i].inv==0){
        if((tx==itm[i].x)&&(ty==itm[i].y)) break;
      }
    }
    sprintf(buf,"\nɂ%s",itm[i].name);
  }

  strcat(message,buf);

  return map[ty][tx];
}

void kill(i,x,y){
  char ent;
  int j,k;
  int b;

  map[y][x]=npc[i].place;
  mi[y][x]=chip[npc[i].place];
  pc.exp=pc.exp+npc[i].exp*depth/pc.lv;

  if(rand()%16==0){
    sprintf(buf,"\nɓꂽ");
    strcat(message,buf);
    for(i=0;i<maxmat;i++){
      if(mat[i][0]==24){
        mat[i][1]++;
        break;
      }
      if(mat[i][0]==-1){
        mat[i][0]=24;
        mat[i][1]=1;
        break;
      }
    }
    if(i==maxmat){
      sprintf(buf,"\nȏ㎝ĂȂ");
      strcat(message,buf);
    }
  }

  if(pc.exp>100){
    sprintf(buf,"\nȂ̓xAbv");
    while(pc.exp>=100){
      pc.lv++;
      pc.mhp=pc.mhp+dice(3,5,5);
      pc.mhp=pc.mmp+dice(3,5,5);
      pc.par.pow=pc.par.pow+dice(2,3,1);
      pc.par.def=pc.par.def+dice(2,3,1);
      pc.par.dex=pc.par.dex+dice(2,3,1);
      pc.par.mag=pc.par.mag+dice(2,3,1);
      pc.exp=pc.exp-100;
    }

    if((pc.lv%3==0)&&(pc.lv<20)){
      b=1;
      while(b==1){
        system("cls");
        printf("̖@oH\n\n");
        for(i=0;i<sizeof magiclist/sizeof magiclist[0];i++){
          printf("%s\n",magiclist[i].name);
        }
        ent=mygetch();
        k=alp2int(ent);
        b=0;
        for(j=0;pc.magic[j]!=-1;j++){
          if(pc.magic[j]==k){
            b=1;
            break;
          }
        }
        if(b==1) printf("̖@͂oĂ");
      }
      pc.magic[j]=k;
      printf("Ȃ%s̖@o",magiclist[k].name);
    }
  }
}

void itemconsume(num,n){
  int i;

  inv[num][1]=inv[num][1]-n;
  if(inv[num][1]<=0){
    for(i=num;i<maxinv-1;i++){
      inv[i][0]=inv[i+1][0];
      inv[i][1]=inv[i+1][1];
    }
    inv[maxinv-1][0]=-1;
  }
}

void materialconsume(num,n){
  int i;

  mat[num][1]=mat[num][1]-n;
  if(mat[num][1]<=0){
    for(i=num;i<maxmat-1;i++){
      mat[i][0]=mat[i+1][0];
      mat[i][1]=mat[i+1][1];
    }
    mat[maxmat-1][0]=-1;
  }
}

void useitem(i){
  int damage;
  int b,x,y;

  damage=itemlist[i].hp*dice(2,depth,10)/10;
  pc.hp=pc.hp+damage;
  if(damage==0){
  }else if(damage>0){
    sprintf(buf,"\nȂ%d񕜂",damage);
    strcat(message,buf);
  }else{
    sprintf(buf,"\nȂ%d̃_[W󂯂",-damage);
    strcat(message,buf);
  }

  damage=itemlist[i].mp*dice(2,depth,10)/10;
  pc.mp=pc.mp+damage;
  if(damage==0){
  }else if(damage>0){
    sprintf(buf,"\nȂMP%d񕜂",damage);
    strcat(message,buf);
    if(pc.mmp<pc.mp) pc.mp=pc.mmp;
  }else{
    sprintf(buf,"\nȂ%dMPDꂽ",-damage);
    strcat(message,buf);
    if(pc.mp<0) pc.mp=0;
  }

  if(pc.pars.pow[1]<itemlist[i].pars.pow[1]){
    damage=itemlist[i].pars.pow[0]*dice(2,depth,10)/10;
    if(damage==0){
    }else if(damage>0){
      sprintf(buf,"\nȂ̍U͂%dオ",damage);
      strcat(message,buf);
    }else{
      sprintf(buf,"\nȂ̍U͂%d",-damage);
      strcat(message,buf);
    }
    pc.pars.pow[0]=pc.par.pow+damage;
    pc.pars.pow[1]=itemlist[i].pars.pow[1];
  }
  

  if(pc.pars.def[1]<itemlist[i].pars.pow[1]){
    damage=itemlist[i].pars.def[0]*dice(2,depth,10)/10;
    if(damage==0){
    }else if(damage>0){
      sprintf(buf,"\nȂ̖h͂%dオ",damage);
      strcat(message,buf);
    }else{
      sprintf(buf,"\nȂ̖h͂%d",-damage);
      strcat(message,buf);
    }
    pc.pars.def[0]=pc.par.def+damage;
    pc.pars.def[1]=itemlist[i].pars.def[1];
  }

  if(pc.pars.dex[1]<itemlist[i].pars.dex[1]){
    damage=itemlist[i].pars.dex[0]*dice(2,depth,10)/10;
    if(damage==0){
    }else if(damage>0){
      sprintf(buf,"\nȂ̊p%dオ",damage);
      strcat(message,buf);
    }else{
      sprintf(buf,"\nȂ̊p%d",-damage);
      strcat(message,buf);
    }
    pc.pars.dex[0]=pc.par.dex+damage;
    pc.pars.dex[1]=itemlist[i].pars.dex[1];
  }

  if(pc.pars.mag[1]<itemlist[i].pars.mag[1]){
    damage=itemlist[i].pars.mag[0]*dice(2,depth,10)/10;
    if(damage==0){
    }else if(damage>0){
      sprintf(buf,"\nȂ̖͂%dオ",damage);
      strcat(message,buf);
    }else{
      sprintf(buf,"\nȂ̖͂%d",-damage);
      strcat(message,buf);
    }
    pc.pars.mag[0]=pc.par.mag+damage;
    pc.pars.mag[1]=itemlist[i].pars.mag[1];
  }

  if(pc.pars.spd[1]<itemlist[i].pars.spd[1]){
    damage=itemlist[i].pars.spd[0]*dice(2,depth,10)/10;
    if(damage==0){
    }else if(damage>0){
      sprintf(buf,"\nȂ̑%dオ",damage);
      strcat(message,buf);
    }else{
      sprintf(buf,"\nȂ̑%d",-damage);
      strcat(message,buf);
    }
    pc.pars.spd[0]=pc.par.spd+damage;
    pc.pars.spd[1]=itemlist[i].pars.spd[1];
  }

  if(i==14){ //V[ge|[g̊
    b=1;
    while(b==1){
      x=5-rand()%10;
      y=5-rand()%10;
      if((map[pc.y+y][pc.x+x]==0)||
         (map[pc.y+y][pc.x+x]==2)){
        b=0;
      }
    }
    map[pc.y][pc.x]=pc.place;
    mi[pc.y][pc.x]=chip[pc.place];
    pc.x=pc.x+x;
    pc.y=pc.y+y;
    map[pc.y][pc.x]=10;
    sprintf(buf,"\nȂ̓V[ge|[g̊ǂ");
    strcat(message,buf);
  }

  if(i==15){ //e|[g̊
    b=1;
    while(b==1){
      x=rand()%40;
      y=rand()%40;
      if(map[y][x]==0) b=0;
    }
    map[pc.y][pc.x]=0;
    mi[pc.y][pc.x]=chip[0];
    pc.x=x;
    pc.y=y;
    map[pc.y][pc.x]=10;
    sprintf(buf,"\nȂ̓e|[g̊ǂ");
    strcat(message,buf);
  }

  if(i==16){ //A҂̊
    tohouse=10;
  }

  if(i==52){ //x_E̖
    if(pc.lv!=1){
      pc.lv--;
      pc.mhp=pc.mhp-dice(3,5,5);
      pc.mhp=pc.mmp-dice(3,5,5);
      pc.par.pow=pc.par.pow-dice(2,3,1);
      pc.par.def=pc.par.def-dice(2,3,1);
      pc.par.dex=pc.par.dex-dice(2,3,1);
      pc.par.mag=pc.par.mag-dice(2,3,1);
      pc.exp=0;
    }
  }
}

void useitemnpc(i,j){
  int damage;

  damage=itemlist[inv[i][0]].hp*dice(2,depth,10)/10;
  npc[j].hp=npc[j].hp+damage;
  if(damage==0){
  }else if(damage<0){
    if(npc[j].hp<0){
      sprintf(buf,"\n%s%d̃_[W󂯂Ď",npc[j].name,-damage);
      strcat(message,buf);
      kill(j,npc[j].x,npc[j].y);
    }else{
      sprintf(buf,"\n%s%d̃_[W󂯂",npc[j].name,-damage);
      strcat(message,buf);
    }
  }else{
    sprintf(buf,"\n%s%d񕜂",npc[j].name,damage);
    strcat(message,buf);
    if(npc[j].mhp<npc[j].hp) npc[j].hp=npc[j].mhp;
  }
  
  damage=itemlist[inv[i][0]].mp*dice(2,depth,10)/10;
  npc[j].mp=npc[j].mp+damage;
  if(damage==0){
  }else if(damage<0){
    if(npc[j].mp<0) npc[j].mp=0;
    sprintf(buf,"\n%s%dMPDꂽ",npc[j].name,-damage);
    strcat(message,buf);
  }else{
    sprintf(buf,"\n%s%dMP񕜂",npc[j].name,damage);
    strcat(message,buf);
    if(npc[j].mmp<npc[j].mp) npc[j].mp=npc[j].mmp;
  }
  
  damage=itemlist[inv[i][0]].pars.pow[0]*dice(2,depth,10)/10;
  if(damage==0){
  }else if(damage<0){
    if(npc[j].mp<0) npc[j].mp=0;
    sprintf(buf,"\n%s̍U͂%d",npc[j].name,-damage);
    strcat(message,buf);
  }else{
    sprintf(buf,"\n%s̍U͂%dオ",npc[j].name,damage);
    strcat(message,buf);
  }
  npc[j].pars.pow[0]=npc[j].par.pow+damage;
  if(itemlist[inv[i][0]].pars.pow[1]!=0) npc[j].pars.pow[1]=itemlist[inv[i][0]].pars.pow[1];
  
  damage=itemlist[inv[i][0]].pars.def[0]*dice(2,depth,10)/10;
  if(damage==0){
  }else if(damage<0){
    if(npc[j].mp<0) npc[j].mp=0;
    sprintf(buf,"\n%s̖h͂%d",npc[j].name,-damage);
    strcat(message,buf);
  }else{
    sprintf(buf,"\n%s̖h͂%dオ",npc[j].name,damage);
    strcat(message,buf);
  }
  npc[j].pars.def[0]=npc[j].par.def+damage;
  if(itemlist[inv[i][0]].pars.def[1]!=0) npc[j].pars.def[1]=itemlist[inv[i][0]].pars.def[1];
  
  damage=itemlist[inv[i][0]].pars.dex[0]*dice(2,depth,10)/10;
  if(damage==0){
  }else if(damage<0){
    if(npc[j].mp<0) npc[j].mp=0;
    sprintf(buf,"\n%s̊p%d",npc[j].name,-damage);
    strcat(message,buf);
  }else{
    sprintf(buf,"\n%s̊p%dオ",npc[j].name,damage);
    strcat(message,buf);
  }
  npc[j].pars.dex[0]=npc[j].par.dex+damage;
  if(itemlist[inv[i][0]].pars.dex[1]!=0) npc[j].pars.dex[1]=itemlist[inv[i][0]].pars.dex[1];
  
  damage=itemlist[inv[i][0]].pars.mag[0]*dice(2,depth,10)/10;
  if(damage==0){
  }else if(damage<0){
    if(npc[j].mp<0) npc[j].mp=0;
    sprintf(buf,"\n%s̖͂%d",npc[j].name,-damage);
    strcat(message,buf);
  }else{
    sprintf(buf,"\n%s̖͂%dオ",npc[j].name,damage);
    strcat(message,buf);
  }
  npc[j].pars.mag[0]=npc[j].par.mag+damage;
  if(itemlist[inv[i][0]].pars.mag[1]!=0) npc[j].pars.mag[1]=itemlist[inv[i][0]].pars.mag[1];
  
  damage=itemlist[inv[i][0]].pars.spd[0]*dice(2,depth,10)/10;
  if(damage==0){
  }else if(damage<0){
    if(npc[j].mp<0) npc[j].mp=0;
    sprintf(buf,"\n%s̑%d",npc[j].name,-damage);
    strcat(message,buf);
  }else{
    sprintf(buf,"\n%s̑%dオ",npc[j].name,damage);
    strcat(message,buf);
  }
  npc[j].pars.spd[0]=npc[j].par.spd+damage;
  if(itemlist[inv[i][0]].pars.spd[1]!=0) npc[j].pars.spd[1]=itemlist[inv[i][0]].pars.spd[1];
}

void init(num){
  int i;
  char ent;
  char filename[16];
  int mode;
  FILE* f;

  setnpclist();
  gathering[2]=0;
  eat[1]=0;
  rest=0;
  depth=0;

  if(num==-1){

    year=0;
    month=0;
    day=0;
    hour=0;
    min=0;

    for(i=0;i<16;i++) crp[i].prop=-1;

    //PC̑ݒ
    pc.wear.pow=0;
    pc.wear.def=0;
    pc.wear.dex=0;
    pc.wear.mag=0;
    pc.wear.spd=0;

    //PC̃Xe[^X
    pc.lv=1;
    pc.exp=0;
    pc.stm=1000;
    pc.par.pow=dice(3,5,5);
    pc.par.def=dice(3,5,5);
    pc.par.dex=dice(3,5,5);
    pc.par.mag=dice(3,5,5);
    pc.par.spd=60;
    pc.mhp=dice(4,10,10);
    pc.mmp=dice(4,5,10);
    pc.hp=pc.mhp;
    pc.mp=pc.mmp;
    pc.pars.pow[0]=pc.par.pow;
    pc.pars.def[0]=pc.par.def;
    pc.pars.dex[0]=pc.par.dex;
    pc.pars.mag[0]=pc.par.mag;
    pc.pars.spd[0]=pc.par.spd;
    pc.pars.pow[1]=0;
    pc.pars.def[1]=0;
    pc.pars.dex[1]=0;
    pc.pars.mag[1]=0;
    pc.pars.spd[1]=0;
    for(i=0;i<32;i++){
      inv[i][0]=-1;
      mat[i][0]=-1;
      equipment[i][0]=-1;
    }
    for(i=0;i<32;i++) pc.magic[i]=-1;
    farmlv=1;
    warehouselv=1;
    townlv=1;
    shoplv=1;
    money=10000;
    for(i=0;i<32;i++){
      warehouseitm[i][0]=-1;
      warehousemat[i][0]=-1;
      equipmyshop[i][0]=-1;
      itemmyshop[i][0]=-1;
    }
    tonpcshop();

    skl.makeequip[0]=1;
    skl.tool[0]=1;
    skl.cook[0]=1;
    skl.dig[0]=1;
    skl.fell[0]=1;
    skl.fishing[0]=1;
    skl.plant[0]=1;
    skl.trade[0]=1;
    skl.makeequip[1]=10;
    skl.tool[1]=10;
    skl.cook[1]=10;
    skl.dig[1]=10;
    skl.fell[1]=10;
    skl.fishing[1]=10;
    skl.plant[1]=10;
    skl.trade[1]=10;

    system("cls");
    printf("OĂȂ\n");
    scanf("%s",pc.name);

    //Փxݒ
    system("cls");
    printf("ՓxIł\n\n");
    printf("a:Easy\n");
    printf("b:Normal\n");
    printf("c:Hard\n");
    printf("d:Extra");

    ent=mygetch();
    switch(ent){
    case 'a':
      numnpc=16;
      numitem=32;
      maxinv=32;
      maxmat=32;
      maxequip=32;
      excite=5;
      stayfloor=1000;
      break;
    case 'b':
      numnpc=32;
      numitem=16;
      maxinv=16;
      maxmat=16;
      maxequip=16;
      excite=7;
      stayfloor=800;
      break;
    case 'c':
      numnpc=64;
      numitem=8;
      excite=10;
      maxinv=8;
      maxmat=8;
      maxequip=8;
      stayfloor=500;
      break;
    case 'd':
      numnpc=128;
      numitem=4;
      excite=15;
      maxinv=4;
      maxmat=4;
      maxequip=4;
      stayfloor=300;
      break;
    default:
      numnpc=32;
      numitem=16;
      maxinv=16;
      maxmat=16;
      maxequip=16;
      excite=7;
      stayfloor=800;
    }
  }else{
    sprintf(filename,"save/save%d",num);
    f=fopen(filename,"r");

    fscanf(f,"%d",&mode);
    switch(mode){
    case 0:
      numnpc=16;
      numitem=32;
      maxinv=32;
      maxmat=32;
      maxequip=32;
      excite=5;
      stayfloor=1000;
      break;
    case 1:
      numnpc=32;
      numitem=16;
      maxinv=16;
      maxmat=16;
      maxequip=16;
      excite=7;
      stayfloor=800;
      break;
    case 2:
      numnpc=64;
      numitem=8;
      excite=10;
      maxinv=8;
      maxmat=8;
      maxequip=8;
      stayfloor=500;
      break;
    case 3:
      numnpc=128;
      numitem=4;
      excite=15;
      maxinv=4;
      maxmat=4;
      maxequip=4;
      stayfloor=300;
      break;
    }

    fscanf(f,"%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
          &pc.name,
          &pc.mhp,&pc.mmp,
          &pc.par.pow,&pc.par.def,&pc.par.dex,&pc.par.mag,&pc.par.spd,
          &pc.wear.pow,&pc.wear.def,&pc.wear.dex,&pc.wear.mag,&pc.wear.spd,
          &pc.lv,&pc.exp
          ); //Xe[^X
    fscanf(f,"%d %d %d %d %d",&pc.wear.pow,&pc.wear.def,&pc.wear.dex,&pc.wear.mag,&pc.wear.spd); //i
    for(i=0;i<32;i++){
      fscanf(f,"%d",&pc.magic[i]); //@
    }
    fscanf(f,"%d %d %d %d %d %d %d",&year,&month,&day,&hour,&min,&pc.stm,&money); //ԁA
    for(i=0;i<maxinv;i++) fscanf(f,"%d %d",&inv[i][0],&inv[i][1]); //ACe
    for(i=0;i<maxmat;i++) fscanf(f,"%d %d",&mat[i][0],&mat[i][1]); //}eA
    for(i=0;i<maxequip;i++) fscanf(f,"%d %d",&equipment[i][0],&equipment[i][1]); //i
    fscanf(f,"%d %d",&skl.makeequip[0],&skl.makeequip[1]); //XL
    fscanf(f,"%d %d",&skl.tool[0],&skl.tool[1]);
    fscanf(f,"%d %d",&skl.cook[0],&skl.cook[1]);
    fscanf(f,"%d %d",&skl.dig[0],&skl.dig[1]);
    fscanf(f,"%d %d",&skl.fell[0],&skl.fell[1]);
    fscanf(f,"%d %d",&skl.fishing[0],&skl.fishing[1]);
    fscanf(f,"%d %d",&skl.plant[0],&skl.plant[1]);
    fscanf(f,"%d %d",&skl.trade[0],&skl.trade[1]);
    fscanf(f,"%d %d %d %d",&warehouselv,&farmlv,&townlv,&shoplv); //K
    for(i=0;i<warehouselv;i++) fscanf(f,"%d %d",&warehouseitm[i][0],&warehouseitm[i][1]);
    for(i=0;i<warehouselv;i++) fscanf(f,"%d %d",&warehousemat[i][0],&warehousemat[i][1]);
    for(i=0;i<farmlv;i++) fscanf(f,"%d %d %d %d %d %d",
                                 &crp[i].prop,&crp[i].planted[0],&crp[i].planted[1],&crp[i].planted[2],&crp[i].planted[3],&crp[i].hrd);
    for(i=0;i<shoplv;i++) fscanf(f,"%d %d %d",&equipmyshop[i][0],&equipmyshop[i][1],&equipmyshop[i][2]); //X葕
    for(i=0;i<shoplv;i++) fscanf(f,"%d %d %d",&itemmyshop[i][0],&itemmyshop[i][1],&itemmyshop[i][2]); //XACe
    for(i=0;i<townlv;i++) fscanf(f,"%d %d ",&itemnpcshop[i][0],&itemnpcshop[i][1]); //XACe
    for(i=0;i<townlv;i++) fscanf(f,"%d %d ",&equipnpcshop[i][0],&equipnpcshop[i][1]); //X葕

    fclose(f);

    pc.hp=pc.mhp;
    pc.mp=pc.mmp;
    pc.pars.pow[0]=pc.par.pow;
    pc.pars.def[0]=pc.par.def;
    pc.pars.dex[0]=pc.par.dex;
    pc.pars.mag[0]=pc.par.mag;
    pc.pars.spd[0]=pc.par.spd;
    pc.pars.pow[1]=0;
    pc.pars.def[1]=0;
    pc.pars.dex[1]=0;
    pc.pars.mag[1]=0;
    pc.pars.spd[1]=0;
  }

  sprintf(para,"U:%d h:%d p:%d :%d :%d",pc.par.pow,pc.par.def,pc.par.dex,pc.par.mag,pc.par.spd);
  sprintf(status,"Lv:%d HP:%d/%d MP:%d/%d :%d Lv܂%d",pc.lv,pc.hp,pc.mhp,pc.mp,pc.mmp,arrow,100-pc.exp);
}

int targetselect(void){
  char ent=0;
  int j;

  ent=0;
  tx=pc.x;
  ty=pc.y;

  while(ent!='t'){

    draw();

    ent=mygetch();
    switch(ent){
    case ENTER:
      ent='t';
      break;
    case UP:
      ty=targetmove(pc.y,ty,-1);
      break;
    case DOWN:
      ty=targetmove(pc.y,ty,1);
      break;
    case RIGHT:
      tx=targetmove(pc.x,tx,1);
      break;
    case LEFT:
      tx=targetmove(pc.x,tx,-1);
      break;
    case ESC:
    case 'q':
      return -1;
    }

    j=targetinfo();
  }

  return j;
}

char mygetch(void){
  char ent;

  ent=getch();
  if(ent==DIRKEY) ent=getch();

  return ent;
}

int numc2int(char numc[]){
  int ret=0;
  int i,j;

  for(i=0;numc[i]!='\0';i++){
    ret=ret*10;
    for(j=0;j<10;j++){
      if(numlist[j]==numc[i]) break;
    }

    if(j==10){
      return -1;
    }else{
      ret=ret+j;
    }
  }

  return ret;
}

void floordown(d){
  int i;

  depth=depth+d;
  for(i=0;i<sizeof npclist/sizeof npclist[0];i++){
    npclist[i].mhp=npclist[i].mhp+15*d;
    npclist[i].hp=npclist[i].hp+15*d;
    npclist[i].mmp=npclist[i].mmp+15*d;
    npclist[i].mp=npclist[i].mp+15*d;
    npclist[i].par.pow=npclist[i].par.pow+5*d;
    npclist[i].par.def=npclist[i].par.def+5*d;
    npclist[i].par.dex=npclist[i].par.dex+5*d;
    npclist[i].par.mag=npclist[i].par.mag+5*d;

    npclist[i].pars.pow[0]=npclist[i].par.pow;
    npclist[i].pars.def[0]=npclist[i].par.def;
    npclist[i].pars.dex[0]=npclist[i].par.dex;
    npclist[i].pars.mag[0]=npclist[i].par.mag;
  }
  pc.rec=0;

  if(depth==0){
    gathering[2]=0;
    rest=0;
    pc.hp=pc.mhp;
    pc.mp=pc.mmp;
    pc.pars.pow[0]=pc.par.pow;
    pc.pars.pow[1]=0;
    pc.pars.def[0]=pc.par.def;
    pc.pars.def[1]=0;
    pc.pars.dex[0]=pc.par.dex;
    pc.pars.dex[1]=0;
    pc.pars.mag[0]=pc.par.mag;
    pc.pars.mag[1]=0;
    pc.pars.spd[0]=pc.par.spd;
    pc.pars.spd[1]=0;
  }else{
    createmap();
  }
}

void gather(x,y){
  int pl;
  int get;
  int i;

  pl=map[y][x];

  get=rand()%8;
  if(rand()%8<get) get=-1;

  if(get==-1){
    sprintf(buf,"\n̂Ȃ");
  }else{
    switch(pl){
    case 4://
      skl.dig[1]=skl.dig[1]-get;
      break;
    case 5://
      skl.dig[1]=skl.dig[1]-get;
      get=get+16;
      break;
    case 6://؍
      skl.fell[1]=skl.fell[1]-get;
      get=get+8;
      break;
    case 9://
      skl.fishing[1]=skl.fishing[1]-5;
      get=26;
    }
    for(i=0;i<maxmat;i++){
      if(mat[i][0]==get){
        mat[i][1]++;
        break;
      }
      if(mat[i][0]==-1){
        mat[i][0]=get;
        mat[i][1]=1;
        break;
      }
    }
    sprintf(buf,"\n%ŝꂽ",materiallist[get].name);
  }
  strcat(message,buf);

  if(skl.dig[1]<0){
    skl.dig[0]++;
    skl.dig[1]=skl.dig[1]+skl.dig[0]*2;
    sprintf(buf,"\n̍zxUP");
    strcat(message,buf);
  }
  if(skl.fell[1]<0){
    skl.fell[0]++;
    skl.fell[1]=skl.fell[1]+skl.fell[0]*2;
    sprintf(buf,"\ñxUP");
    strcat(message,buf);
  }
  if(skl.fishing[1]<0){
    skl.fishing[0]++;
    skl.fishing[1]=skl.fishing[1]+skl.fishing[0]*2;
    sprintf(buf,"\nނ背xUP");
    strcat(message,buf);
  }

  switch(pl){
  case 4:
  case 5:
    if(trpcalc(depth+skl.dig[0],pc.lv,15)<rand()%100){
      map[y][x]=0;
      mi[y][x]=chip[0];
      sprintf(buf,"\n@s");
      strcat(message,buf);
    }
    break;
  case 6:
    if(trpcalc(depth+skl.fell[0],pc.lv,15)<rand()%100){
      map[y][x]=0;
      mi[y][x]=chip[0];
      sprintf(buf,"\n̂s");
      strcat(message,buf);
    }
    break;
  case 9:
    if(trpcalc(depth+skl.fishing[0],pc.lv,15)<rand()%100){
      map[y][x]=0;
      mi[y][x]=chip[0];
      sprintf(buf,"\n͊オ");
      strcat(message,buf);
    }
  }
}

void randwalk(i){
  if(rand()%3==0){
    switch(rand()%4){
    case 0:
      npcmove(i,1,0);
      break;
    case 1:
      npcmove(i,-1,0);
      break;
    case 2:
      npcmove(i,0,1);
      break;
    case 3:
      npcmove(i,0,-1);
      break;
    }
  }
}

void setnpclist(void){
  int i;

  for(i=0;i<16;i++){
    minenpc[i].rare=0;
    forestnpc[i].rare=0;
    seanpc[i].rare=0;
  }

  minenpc[0]=npclist[0];
  minenpc[1]=npclist[1];
  minenpc[2]=npclist[2];
  minenpc[3]=npclist[3];
  minenpc[4]=npclist[4];
  minenpc[5]=npclist[5];
  minenpc[6]=npclist[10];

  forestnpc[0]=npclist[0];
  forestnpc[1]=npclist[1];
  forestnpc[2]=npclist[2];
  forestnpc[3]=npclist[3];
  forestnpc[4]=npclist[4];
  forestnpc[5]=npclist[5];
  forestnpc[6]=npclist[11];

  seanpc[0]=npclist[4];
  seanpc[1]=npclist[5];
  seanpc[2]=npclist[6];
  seanpc[3]=npclist[7];
  seanpc[4]=npclist[8];
  seanpc[5]=npclist[9];
  seanpc[6]=npclist[12];
}

void timeplus(void){
  int i;

  min=min+6000/(pc.pars.spd[0]+pc.field.spd);
  if(6000<=min){
    min=min-6000;
    hour++;
  }
  if(24<=hour){
    hour=hour-24;
    day++;
    sell();
    tonpcshop();
  }
  if(30<=day){
    day=day-30;
    month++;
  }
  if(12<=month){
    month=month-12;
    year++;
  }

  if(0<pc.stm) pc.stm--;
  if(pc.stm==300){
    sprintf(buf,"\nĂ");
    strcat(message,buf);
  }else if(pc.stm==150){
    sprintf(buf,"\n󕠂Ŗڂ肾");
    strcat(message,buf);
  }else if(pc.stm==50){
    sprintf(buf,"\nĎɂ");
    strcat(message,buf);
  }else if(pc.stm==0){
    sprintf(buf,"\n쎀");
    strcat(message,buf);
  }
}

int grouthcalc(int t[]){
  int y,m,d,h;

  y=t[0]-year;
  m=t[1]-month;
  d=t[2]-day;
  h=t[3]-hour;

  if(h<0){
    h=h+60;
    d--;
  }

  while(y>0){
    m=m+12;
    y--;
  }
  while(m>0){
    d=d+30;
    m--;
  }

  if(d>7){
    return 3;
  }else if(d>3){
    return 2;
  }else if(d>1){
    return 1;
  }else{
    return 0;
  }
}

int start(void){
  char ent;
  int enti;
  int i;
  FILE* f;
  char pcname[16][16];
  int pclv[16];

startselect:
  system("cls");
  printf("悤\n\n\n");
  printf("a:͂߂\n");
  printf("b:Â\n");

  ent=mygetch();
  if(ent=='a'){
    return -1;
  }else if(ent=='b'){
    for(i=0;i<16;i++) pclv[i]=0;
    f=fopen("save/save","r");
    for(i=0;i<16;i++){
      if(fscanf(f,"%s %d",pcname[i],&pclv[i])==EOF) break;
    }
    fclose(f);
  selectdata:
    system("cls");
    printf("Z[uf[^Ił\n\n");
    for(i=0;i<16;i++){
      if(pclv[i]!=0){
        printf("%c:%s(Lv.%d)\n",alphabet[i],pcname[i],pclv[i]);
      }
    }
    ent=mygetch();
    enti=alp2int(ent);
    if(ent==ESC) goto startselect;
    if((enti>=16)||(pclv[enti]==-1)){
      goto selectdata;
    }else{
      return enti;
    }
  }else{
    goto startselect;
  }
}

int drop(void){
  char ent;
  char numc[16];
  int i;
  int enti;
  
dropitem:
  system("cls");
  printf("̂ĂH\n");
  printf("a:ACe\n");
  printf("b:i\n");
  printf("c:f\n");
  printf("ESC:ς߂\n");

  ent=mygetch();
  if(ent==ESC) return 0;
  switch(ent){
  case 'a':
    printf("ǂ̂ĂH\n\n");
    for(i=0;i<maxinv;i++){
      if(inv[i][0]==-1) break;
      if(itemlist[inv[i][0]].prop==4){
        printf("%c:%s(c%d)",alphabet[i],itemlist[inv[i][0]].name,inv[i][1]);
      }else{
        printf("%c:%s x%d\n",alphabet[i],itemlist[inv[i][0]].name,inv[i][1]);
      }
    }
    ent=mygetch();
    if(ent==ESC) return 0;
    enti=alp2int(ent);
    if((inv[enti][0]==-1)||(maxinv<=enti)){
      printf("ȃACe݂͑Ȃ\n");
      printf("L[Ă\n");
      mygetch();
      goto dropitem;
    }
    printf("");
    if(itemlist[inv[enti][0]].prop==4){ //@̏
      printf("%ŝĂH\n",itemlist[inv[enti][0]].name);
      printf("y/n");
      ent=mygetch();
      if(ent=='y'){
        sprintf(buf,"%ŝĂ\n",itemlist[inv[enti][0]].name);
        strcat(message,buf);
        for(i=enti;i<maxinv-1;i++){
          inv[i][0]=inv[i+1][0];
          inv[i][1]=inv[i+1][1];
        }
        inv[maxinv-1][0]=-1;
      }
    }else{
      printf("%s̂ĂH\n",itemlist[inv[enti][0]].name);
      scanf("%s",numc);
      i=numc2int(numc);
      if(0<i){
        if(i<inv[enti][1]){
          sprintf(buf,"%s%d̂Ă",itemlist[inv[enti][0]].name,i);
        }else{
          sprintf(buf,"%sŜĂ",itemlist[inv[enti][0]].name);
        }
        itemconsume(enti,i);
      }
    }
    break;

  case 'b':
    printf("ǂ̂ĂH\n\n");
    for(i=0;i<maxequip;i++){
      if(mat[i][0]==-1) break;
      printf("%c:%s x%d\n",alphabet[i],equiplist[equipment[i][0]],equipment[i][1]);
    }
    ent=mygetch();
    if(ent==ESC) return 0;
    enti=alp2int(ent);
    if((equipment[enti][0]==-1)||(maxequip<=enti)){
      printf("ȃACe݂͑Ȃ\n");
      printf("L[Ă\n");
      mygetch();
      goto dropitem;
    }
    printf("%ŝĂH\n",equiplist[equipment[enti][0]]);
    printf("y/n");
    ent=mygetch();
    if(ent=='y'){
      sprintf(buf,"%ŝĂ\n",equiplist[equipment[enti][0]]);
      strcat(message,buf);
      for(i=enti;i<maxequip-1;i++){
        equipment[i][0]=equipment[i+1][0];
        equipment[i][1]=equipment[i+1][1];
      }
      equipment[maxequip-1][0]=-1;
    }
    break;

  case 'c':
    printf("ǂ̂ĂH\n\n");
    for(i=0;i<maxmat;i++){
      if(mat[i][0]==-1) break;
      printf("%c:%s x%d\n",alphabet[i],materiallist[inv[i][0]].name,mat[i][1]);
    }
    ent=mygetch();
    if(ent==ESC) return 0;
    enti=alp2int(ent);
    if((mat[enti][0]==-1)||(maxmat<=enti)){
      printf("ȃACe݂͑Ȃ\n");
      printf("L[Ă\n");
      mygetch();
      goto dropitem;
    }
    printf("%s̂ĂH\n",materiallist[mat[enti][0]].name);
    scanf("%s",numc);
    i=numc2int(numc);
    if(0<i){
      if(i<inv[enti][1]){
        sprintf(buf,"%s%d̂Ă",materiallist[mat[enti][0]].name,i);
      }else{
        sprintf(buf,"%sŜĂ",materiallist[mat[enti][0]].name);
      }
      materialconsume(enti,i);
    }
    break;
  }
}

void sell(void){
  int i,j;
  int guest;
  int numitm,num;
  int buy;
  int fair;
  int profit=0;
  int sellitem=0;
  int sellequip=0;

  guest=dice(1,skl.trade[0],0);
  for(i=0;i<guest;i++){
    if(rand()%10<3){ //i
      for(numitm=0;numitm<shoplv;numitm++){
        if(equipmyshop[numitm][0]==-1) break;
      }
      buy=rand()%numitm;
      if(rand()%100<dice(1,trpcalc(100+skl.trade[0],equipmyshop[buy][2]/(5*equipmyshop[buy][1]),10),0)){
        profit=profit+equipmyshop[buy][2];
        sellequip++;
        for(j=buy;j<numitm;j++){
          equipmyshop[j][0]=equipmyshop[j+1][0];
          equipmyshop[j][1]=equipmyshop[j+1][1];
          equipmyshop[j][2]=equipmyshop[j+1][2];
        }
      }
    }else{ //ACe
      for(numitm=0;numitm<shoplv;numitm++){
        if(itemmyshop[numitm][0]==-1) break;
      }
      buy=rand()%numitm;
      if(itemlist[itemmyshop[buy][0]].prop==4){ //@̏
        fair=(10+itemmyshop[buy][1])*itemlist[itemmyshop[buy][0]].price;
        if(rand()%100<dice(1,trpcalc(100*skl.trade[0],100*itemmyshop[buy][2]/fair,10),0)){
          profit=profit+itemmyshop[buy][2];
          sellitem++;
          for(j=buy;j<numitm;j++){
            itemmyshop[j][0]=itemmyshop[j+1][0];
            itemmyshop[j][1]=itemmyshop[j+1][1];
            itemmyshop[j][2]=itemmyshop[j+1][2];
          }
        }
      }else{ //̑
        if(rand()%100<dice(1,trpcalc(100+skl.trade[0],100*itemmyshop[buy][2]/itemlist[itemmyshop[buy][0]].price,10)+1,0)){
          num=dice(1,itemmyshop[buy][1],0);
          profit=profit+itemmyshop[buy][2]*num;
          sellitem++;
          itemmyshop[buy][1]=itemmyshop[buy][1]-num;
          if(itemmyshop[buy][1]==0){
            for(j=buy;j<numitm;j++){
              itemmyshop[j][0]=itemmyshop[j+1][0];
              itemmyshop[j][1]=itemmyshop[j+1][1];
              itemmyshop[j][2]=itemmyshop[j+1][2];
            }
          }
        }
      }
    }
  }

  money=money+profit;
  if(profit==0){
    sprintf(buf,"\nȂ̓Xł͉Ȃ");
  }else{
    sprintf(buf,"\nȂ̓X%d̑i%d̃ACe𔄂%d~̎vo",sellequip,sellitem,profit);
  }
  strcat(message,buf);
}

void putmes(void){
  int len,i,f;

  len=strlen(message);
  i=len;
  f=0;
  while(f<8){
    if(i==0) break;
    i--;
    if(message[i]=='\n') f++;
  }

  while(i<len){
    putch(message[i]);
    i++;
  }
}

void make(void){
  char ent;
  int enti;
  char stuff1,stuff2,stuff3;
  int stuff1i,stuff2i,stuff3i;
  int stuff[3];
  int stfav;
  int i,j;
  int prod,q;
  int f;

input:
  system("cls");
  printf("H\n\n");
  printf("a:i\n");
  printf("b:@̏\n");
  printf("c:\n");
  ent=mygetch();

  switch(ent){
  case 'a': //i
    for(i=0;i<maxequip;i++){
      if(equipment[i][0]==-1) break;
    }
    if(i!=maxequip){
      system("cls");
      printf("H\n\n");
      printf("a:\n");
      printf("b:Z\n");
      printf("c:\n");
      printf("d:Xq\n");
      printf("e:C\n");

      f=1;
      while(f==1){
        ent=mygetch();
        enti=alp2int(ent);
        if((0<=enti)&&(enti<5)) f=0;
      }

      system("cls");
      printf("fނṔH\n\n");
      for(j=0;j<maxmat;j++){
        if((mat[j][0]!=-1)&&(materiallist[mat[j][0]].prop==0)){
          printf("%c:%s x%d\n",alphabet[j],materiallist[mat[j][0]].name,mat[j][1]);
        }
      }
      f=1;
      while(f==1){
        stuff1=mygetch();
        if(stuff1==ESC) goto input;
        stuff1i=alp2int(stuff1);
        if((0<=stuff1i)&&(stuff1i<maxmat)&&(mat[stuff1i][0]!=-1)&&(materiallist[mat[stuff1i][0]].prop==0)){
          f=0;
          stuff[0]=mat[stuff1i][0];
          materialconsume(stuff1i,1);
        }else{
          printf("͑IׂȂ\n");
        }
      }

      system("cls");
      printf("fނQ́H\n\n");
      for(j=0;j<maxmat;j++){
        if((mat[j][0]!=-1)&&(materiallist[mat[j][0]].prop==0)){
          printf("%c:%s x%d\n",alphabet[j],materiallist[mat[j][0]].name,mat[j][1]);
        }
      }
      f=1;
      while(f==1){
        stuff2=mygetch();
        if(stuff2==ESC){
          for(i=0;i<maxmat;i++){
            if(mat[i][0]==stuff[0]){
              mat[i][1]++;
              break;
            }
            if(mat[i][0]==-1){
              mat[i][0]=stuff[0];
              mat[i][1]=1;
              break;
            }
          }
          goto input;
        }
        stuff2i=alp2int(stuff2);
        if((0<=stuff2i)&&(stuff2i<maxmat)&&(mat[stuff2i][0]!=-1)&&(materiallist[mat[stuff2i][0]].prop==0)){
          f=0;
          stuff[1]=mat[stuff2i][0];
          materialconsume(stuff2i,1);
        }else{
          printf("͑IׂȂ\n");
        }
      }

      system("cls");
      printf("fނŔH\n\n");
      for(j=0;j<maxmat;j++){
        if((mat[j][0]!=-1)&&(materiallist[mat[j][0]].prop==0)){
          printf("%c:%s x%d\n",alphabet[j],materiallist[mat[j][0]].name,mat[j][1]);
        }
      }
      f=1;
      while(f==1){
        stuff3=mygetch();
        if(stuff3==ESC){
          for(i=0;i<maxmat;i++){
            if(mat[i][0]==stuff[0]){
              mat[i][1]++;
              break;
            }
            if(mat[i][0]==-1){
              mat[i][0]=stuff[0];
              mat[i][1]=1;
              break;
            }
          }
          for(i=0;i<maxmat;i++){
            if(mat[i][0]==stuff[1]){
              mat[i][1]++;
              break;
            }
            if(mat[i][0]==-1){
              mat[i][0]=stuff[1];
              mat[i][1]=1;
              break;
            }
          }
          goto input;
        }
        stuff3i=alp2int(stuff3);
        if((0<=stuff3i)&&(stuff3i<maxmat)&&(mat[stuff3i][0]!=-1)&&(materiallist[mat[stuff3i][0]].prop==0)){
          f=0;
          stuff[2]=mat[stuff3i][0];
          materialconsume(stuff3i,1);
        }else{
          printf("͑IׂȂ\n");
        }
      }

      for(f=0;f<10;f++) timeplus();

      stfav=(materiallist[stuff[0]].lv+materiallist[stuff[1]].lv+materiallist[stuff[2]].lv)/3;
      if(rand()%100<trpcalc(skl.makeequip[0],stfav+pc.lv,20)){ //
        q=dice(stfav/2+1,skl.makeequip[0]/2+1,0);
        equipment[i][0]=enti;
        equipment[i][1]=q;
        printf("Ȃ͐\\%d%s\n",q,equiplist[enti]);
        skl.makeequip[1]=skl.makeequip[1]-(q/10+1);
        while(skl.makeequip[1]<0){
          skl.makeequip[0]++;
          skl.makeequip[1]=skl.makeequip[1]+skl.makeequip[0]*10;
          printf("i샌xUP\n");
        }
      }else{ //s
        printf("Ȃ%s̐Ɏs\n",equiplist[enti]);
      }
    }else{
      printf("Ȃ͑iȏ㎝ĂȂ\n");
    }
    printf("L[Ă\n");
    mygetch();
    break;

  case 'b': //@񐻍
    for(i=0;i<maxinv;i++){
      if(inv[i][0]==-1) break;
    }
    if(i!=maxinv){
      system("cls");
      printf("fނṔH\n\n");
      for(j=0;j<maxmat;j++){
        if((mat[j][0]!=-1)&&(materiallist[mat[j][0]].prop==1)){
          printf("%c:%s x%d\n",alphabet[j],materiallist[mat[j][0]].name,mat[j][1]);
        }
      }
      f=1;
      while(f==1){
        stuff1=mygetch();
        if(stuff1==ESC) goto input;
        stuff1i=alp2int(stuff1);
        if((0<=stuff1i)&&(stuff1i<maxmat)&&(materiallist[mat[stuff1i][0]].prop==1)){
          f=0;
          stuff[0]=mat[stuff1i][0];
          materialconsume(stuff1i,1);
        }else{
          printf("͑IׂȂ\n");
        }
      }

      system("cls");
      printf("fނQ́H\n\n");
      for(j=0;j<maxmat;j++){
        if((mat[j][0]!=-1)&&(materiallist[mat[j][0]].prop==1)){
          printf("%c:%s x%d\n",alphabet[j],materiallist[mat[j][0]].name,mat[j][1]);
        }
      }
      f=1;
      while(f==1){
        stuff2=mygetch();
        if(stuff2==ESC){
          for(i=0;i<maxmat;i++){
            if(mat[i][0]==stuff[0]){
              mat[i][1]++;
              break;
            }
            if(mat[i][0]==-1){
              mat[i][0]=stuff[0];
              mat[i][1]=1;
              break;
            }
          }
          goto input;
        }
        stuff2i=alp2int(stuff2);
        if((0<=stuff2i)&&(stuff2i<maxmat)&&(materiallist[mat[stuff2i][0]].prop==1)){
          f=0;
          stuff[1]=mat[stuff2i][0];
          materialconsume(stuff2i,1);
        }else{
          printf("͑IׂȂ\n");
        }
      }

      system("cls");
      printf("fނŔH\n\n");
      for(j=0;j<maxmat;j++){
        if((mat[j][0]!=-1)&&(materiallist[mat[j][0]].prop==2)){
          printf("%c:%s x%d\n",alphabet[j],materiallist[mat[j][0]].name,mat[j][1]);
        }
      }
      f=1;
      while(f==1){
        stuff3=mygetch();
        if(stuff3==ESC){
          for(i=0;i<maxmat;i++){
            if(mat[i][0]==stuff[0]){
              mat[i][1]++;
              break;
            }
            if(mat[i][0]==-1){
              mat[i][0]=stuff[0];
              mat[i][1]=1;
              break;
            }
          }
          for(i=0;i<maxmat;i++){
            if(mat[i][0]==stuff[1]){
              mat[i][1]++;
              break;
            }
            if(mat[i][0]==-1){
              mat[i][0]=stuff[1];
              mat[i][1]=1;
              break;
            }
          }
          goto input;
        }
        stuff3i=alp2int(stuff3);
        if((0<=stuff3i)&&(stuff3i<maxmat)&&(materiallist[mat[stuff3i][0]].prop==2)){
          f=0;
          stuff[2]=mat[stuff3i][0];
          materialconsume(stuff3i,1);
        }else{
          printf("͑IׂȂ\n");
        }
      }

      for(f=0;f<10;f++) timeplus();

      stfav=(materiallist[stuff[0]].lv+materiallist[stuff[1]].lv+materiallist[stuff[2]].lv)/3;
      if(rand()%100<trpcalc(skl.tool[0],stfav+pc.lv,20)){ //
        f=1;
        while(f==1){
          prod=rand()%(sizeof itemlist/sizeof itemlist[0]);
          if((itemlist[prod].prop==4)&&(rand()%itemlist[prod].rare==0)){
            f=0;
            q=dice(2,trpcalc(stfav+skl.tool[0],itemlist[prod].rare+pc.lv,5)+1,0);
          }
        }
        
        inv[i][0]=prod;
        inv[i][1]=q;
        printf("Ȃ%s(c%d)\n",itemlist[prod].name,q);
        skl.tool[1]=skl.tool[1]-(itemlist[prod].rare*q/10+1);
        while(skl.makeequip[1]<0){
          skl.tool[0]++;
          skl.tool[1]=skl.tool[1]+skl.tool[0]*10;
          printf("샌xUP\n");
        }
      }else{ //s
        printf("Ȃ͖@̐Ɏs\n");
      }
    }else{
      printf("ȏ㎝ĂȂ\n");
    }
    printf("L[Ă\n");
    mygetch();
    break;

  case 'c': //
    for(i=0;i<maxinv;i++){
      if(inv[i][0]==-1) break;
    }
    if(i!=maxinv){
      system("cls");
      printf("ޗ́H\n\n");
      for(j=0;j<maxmat;j++){
        if((mat[j][0]!=-1)&&(materiallist[mat[j][0]].prop==3)){
          printf("%c:%s x%d\n",alphabet[j],materiallist[mat[j][0]].name,mat[j][1]);
        }
      }
      f=1;
      while(f==1){
        stuff1=mygetch();
        if(stuff1==ESC) goto input;
        stuff1i=alp2int(stuff1);
        if((0<=stuff1i)&&(stuff1i<maxmat)&&(materiallist[mat[stuff1i][0]].prop==3)){
          f=0;
          stuff[0]=mat[stuff1i][0];
          materialconsume(stuff1i,1);
        }else{
          printf("͑IׂȂ\n");
        }
      }

      for(f=0;f<10;f++) timeplus();

      if(rand()%100<trpcalc(skl.cook[0],pc.lv,50)){ //
        f=1;
        while(f==1){
          prod=rand()%5;
          if(rand()%(prod*prod)==0){
            f=0;
          }
        }

        switch(stuff[0]){
        case 24:
          inv[i][0]=prod+20;
          break;
        case 25:
          inv[i][0]=prod+25;
          break;
        case 26:
          inv[i][0]=prod+30;
          break;
        case 27:
          inv[i][0]=prod+35;
          break;
        }
        inv[i][1]=1;
        printf("Ȃ%s\n",itemlist[inv[i][0]].name);
        skl.cook[1]=skl.cook[1]-(prod+1);
        while(skl.makeequip[1]<0){
          skl.tool[0]++;
          skl.tool[1]=skl.tool[1]+skl.tool[0]*10;
          printf("xUP\n");
        }
      }else{ //s
        printf("Ȃ͗Ɏs\n");
      }
    }else{
      printf("ȏ㎝ĂȂ\n");
    }
    printf("L[Ă\n");
    mygetch();
    break;
  }
}

void tonpcshop(void){
  int i;
  int art,num;
  int f;

  for(i=0;i<32;i++){
    f=1;
    while(f==1){
      art=rand()%(sizeof itemlist/sizeof itemlist[0]);
      if(itemlist[art].rare!=0){
        if(rand()%itemlist[art].rare==0){
          itemnpcshop[i][0]=art;
          f=0;
        }
      }
    }
    num=dice(1,trpcalc(townlv,itemlist[art].rare,5)+1,0);
    itemnpcshop[i][1]=num;

    f=1;
    while(f==1){
      art=rand()%5;
      num=rand()%(townlv)+1;
      if(rand()%num==0){
        equipnpcshop[i][0]=art;
        equipnpcshop[i][1]=num;
        f=0;
      }
    }
  }
}

void buy(void){
  char ent1,ent2[16];
  int ent1i,ent2i;
  int i,j;

  system("cls");
  printf("𔃂H\t:%d~\n\n",money);
  printf("a:ACe\n");
  printf("b:i\n");
  ent1=mygetch();
  switch(ent1){
  case 'a':
    while(1==1){
      system("cls");
      printf("𔃂H\t:%d~\n\n",money);
      for(i=0;i<townlv;i++){
        if(itemnpcshop[i][0]!=-1){
          if(itemlist[itemnpcshop[i][0]].prop==4){
            printf("%c:%s(c%d)\t%d~\n",
                   alphabet[i],
                   itemlist[itemnpcshop[i][0]].name,
                   itemnpcshop[i][1],
                   itemlist[itemnpcshop[i][0]].price*2*(10+itemnpcshop[i][1]));
          }else{
            printf("%c:%s x%d\t%d~\n",
                   alphabet[i],
                   itemlist[itemnpcshop[i][0]].name,
                   itemnpcshop[i][1],
                   itemlist[itemnpcshop[i][0]].price*2);
          }
        }
      }

      ent1=mygetch();
      if(ent1==ESC) break;
      ent1i=alp2int(ent1);
      if((ent1i<0)||(townlv<=ent1i)||(itemnpcshop[ent1i][1]==0)||(itemnpcshop[ent1i][0]==-1)){
        printf("͔Ȃ\n");
        printf("L[Ă\n");
        mygetch();
      }else{
        if(itemlist[itemnpcshop[ent1i][0]].prop==4){
          for(i=0;i<maxinv;i++){
            if(inv[i][0]==-1) break;
          }
          if(i==maxinv){
            printf("ȏ㎝ĂȂ\n");
            printf("L[Ă\n");
            mygetch();
          }else{
            if(money<itemlist[itemnpcshop[i][0]].price*2*(10+itemnpcshop[i][1])){
              printf("Ȃ\n");
              printf("L[Ă\n");
              mygetch();
            }else{
              money=money-itemlist[itemnpcshop[i][0]].price*2*(10+itemnpcshop[i][1]);
              inv[i][0]=itemnpcshop[ent1i][0];
              inv[i][1]=itemnpcshop[ent1i][1];
              itemnpcshop[ent1i][0]=-1;
            }
          }
        }else{
          for(i=0;i<maxinv;i++){
            if(inv[i][0]==-1) break;
            if(inv[i][0]==itemnpcshop[ent1i][0]) break;
          }
          if(i==maxinv){
            printf("ȏ㎝ĂȂ\n");
            printf("L[Ă\n");
            mygetch();
          }else{
            printf("H\n");
            scanf("%s",ent2);
            ent2i=numc2int(ent2);

            if(ent2i<0){
            }else{
              if(ent2i<itemnpcshop[ent1i][1]){
                if(money<itemlist[itemnpcshop[ent1i][0]].price*2*ent2i){
                  printf("Ȃ\n");
                }else{
                  if(inv[i][0]==-1){
                    inv[i][0]=itemnpcshop[ent1i][0];
                    inv[i][1]=ent2i;
                    itemnpcshop[ent1i][1]=itemnpcshop[ent1i][1]-ent2i;
                  }else{
                    inv[i][1]=inv[i][1]+ent2i;
                    itemnpcshop[ent1i][1]=itemnpcshop[ent1i][1]-ent2i;
                  }
                  money=money-itemlist[itemnpcshop[ent1i][0]].price*2*ent2i;
                  printf("%s%d\n",itemlist[itemnpcshop[ent1i][0]].name,ent2i);
                }
              }else{
                if(money<itemlist[itemnpcshop[ent1i][0]].price*2*itemnpcshop[ent1i][1]){
                  printf("Ȃ\n");
                }else{
                  money=money-itemlist[itemnpcshop[ent1i][0]].price*2*itemnpcshop[ent1i][1];
                  if(inv[i][0]==-1){
                    inv[i][0]=itemnpcshop[ent1i][0];
                    inv[i][1]=itemnpcshop[ent1i][1];
                    itemnpcshop[ent1i][1]=0;
                  }else{
                    inv[i][1]=inv[i][1]+itemnpcshop[ent1i][1];
                    itemnpcshop[ent1i][1]=0;
                  }
                  printf("%sS\n",itemlist[itemnpcshop[ent1i][0]].name);
                }
              }
              printf("L[Ă\n");
              mygetch();
            }
          }
        }
      }
    }
    break;

  case 'b':
    while(1==1){
      for(i=0;i<maxequip;i++){
        if(equipment[i][0]==-1) break;
      }
      if(i==maxequip){
        printf("ȏ㔃Ȃ\n");
        printf("L[Ă");
        mygetch();
        break;
      }

      system("cls");
      printf("𔃂H\t:%d~\n\n",money);
      for(j=0;j<townlv;j++){
        if(equipnpcshop[j][0]!=-1){
          printf("%c:%s(\\%d)\t%d~\n",
                 alphabet[j],
                 equiplist[equipnpcshop[j][0]],
                 equipnpcshop[j][1],
                 equipnpcshop[j][1]*700);
        }
      }

      ent1=mygetch();
      if(ent1==ESC) break;
      ent1i=alp2int(ent1);
      if((ent1i<0)||(townlv<=ent1i)||(equipnpcshop[ent1i][0]==-1)){
        printf("͔Ȃ\n");
      }else{
        if(money<equipnpcshop[i][1]*700){
          printf("Ȃ\n");
        }else{
          equipment[i][0]=equipnpcshop[ent1i][0];
          equipment[i][1]=equipnpcshop[ent1i][1];
          money=money-equipnpcshop[i][1]*700;
          equipnpcshop[i][0]=-1;
        }
      }
      printf("L[Ă\n");
      mygetch();
    }
    break;
  }
}

void wearing(void){
  char ent;
  int enti;
  int i;
  int eq;

  while(1==1){
    system("cls");
    printf("ǂH\n\n");
    printf("a:\n");
    printf("b:͂\n");

    ent=mygetch();
    if(ent==ESC) break;
    switch(ent){
    case 'a':
      system("cls");
      printf("ǂ𑕔H\n\n");
      for(i=0;i<maxequip;i++){
        if(equipment[i][0]==-1) break;
        printf("%c:%s(\\%d)\n",alphabet[i],equiplist[equipment[i][0]],equipment[i][1]);
      }
      ent=mygetch();
      enti=alp2int(ent);
      if((enti<0)||(maxequip<=enti)||(equipment[enti][0]==-1)){
        printf("͑łȂ\n");
        printf("L[Ă\n");
        mygetch();
      }else{
        switch(equipment[enti][0]){
        case 0:
          eq=pc.wear.pow;
          pc.wear.pow=equipment[enti][1];
          if(eq==0){
            for(i=enti;i<maxequip-1;i++){
              equipment[i][0]=equipment[i+1][0];
              equipment[i][1]=equipment[i+1][1];
            }
            equipment[maxequip-1][0]=-1;
          }else{
            equipment[enti][1]=eq;
          }
          break;
        case 1:
          eq=pc.wear.def;
          pc.wear.def=equipment[enti][1];
          if(eq==0){
            for(i=enti;i<maxequip-1;i++){
              equipment[i][0]=equipment[i+1][0];
              equipment[i][1]=equipment[i+1][1];
            }
            equipment[maxequip-1][0]=-1;
          }else{
            equipment[enti][1]=eq;
          }
          break;
        case 2:
          eq=pc.wear.dex;
          pc.wear.dex=equipment[enti][1];
          if(eq==0){
            for(i=enti;i<maxequip-1;i++){
              equipment[i][0]=equipment[i+1][0];
              equipment[i][1]=equipment[i+1][1];
            }
            equipment[maxequip-1][0]=-1;
          }else{
            equipment[enti][1]=eq;
          }
          break;
        case 3:
          eq=pc.wear.mag;
          pc.wear.mag=equipment[enti][1];
          if(eq==0){
            for(i=enti;i<maxequip-1;i++){
              equipment[i][0]=equipment[i+1][0];
              equipment[i][1]=equipment[i+1][1];
            }
            equipment[maxequip-1][0]=-1;
          }else{
            equipment[enti][1]=eq;
          }
          break;
        case 4:
          eq=pc.wear.spd;
          pc.wear.spd=equipment[enti][1];
          if(eq==0){
            for(i=enti;i<maxequip-1;i++){
              equipment[i][0]=equipment[i+1][0];
              equipment[i][1]=equipment[i+1][1];
            }
            equipment[maxequip-1][0]=-1;
          }else{
            equipment[enti][1]=eq;
          }
          break;
        }
        printf("L[Ă\n");
        mygetch();
      }
      break;
    case 'b':
      for(i=0;i<maxequip;i++){
        if(equipment[i][0]==-1) break;
      }
      if(i==maxequip){
        printf("iȏɎĂȂ\n");
        printf("L[Ă\n");
        mygetch();
      }else{
        system("cls");
        printf("ǂ͂H\n\n");
        if(0<pc.wear.pow) printf("a:(\\%d)\n",pc.wear.pow);
        if(0<pc.wear.def) printf("b:Z(\\%d)\n",pc.wear.def);
        if(0<pc.wear.dex) printf("c:(\\%d)\n",pc.wear.dex);
        if(0<pc.wear.mag) printf("d:Xq(\\%d)\n",pc.wear.mag);
        if(0<pc.wear.spd) printf("e:C(\\%d)\n",pc.wear.spd);

        ent=mygetch();
        enti=alp2int(ent);
        switch(enti){
        case 0:
          if(0<pc.wear.pow) {
            equipment[i][0]=0;
            equipment[i][1]=pc.wear.pow;
            pc.wear.pow=0;
            printf("͂\n");
          }else{
            printf("͑ĂȂ\n");
          }
          printf("L[Ă\n");
          mygetch();
          break;
        case 1:
          if(0<pc.wear.def){ 
            equipment[i][0]=1;
            equipment[i][1]=pc.wear.def;
            pc.wear.def=0;
            printf("Z͂\n");
          }else{
            printf("Z͑ĂȂ\n");
          }
          printf("L[Ă\n");
          mygetch();
          break;
        case 2:
          if(0<pc.wear.dex){
            equipment[i][0]=2;
            equipment[i][1]=pc.wear.dex;
            pc.wear.dex=0;
            printf("͂\n");
          }else{
            printf("͑ĂȂ\n");
          }
          printf("L[Ă\n");
          mygetch();
          break;
        case 3:
          if(0<pc.wear.mag){ 
            equipment[i][0]=3;
            equipment[i][1]=pc.wear.mag;
            pc.wear.mag=0;
            printf("Xq͂\n");
          }else{
            printf("Xq͑ĂȂ\n");
          }
          printf("L[Ă\n");
          mygetch();
          break;
        case 4:
          if(0<pc.wear.spd){ 
            equipment[i][0]=4;
            equipment[i][1]=pc.wear.spd;
            pc.wear.spd=0;
            printf("C͂\n");
          }else{
            printf("C͑ĂȂ\n");
          }
          printf("L[Ă\n");
          mygetch();
          break;
        }
      }
      break;
    }
  }
}